/*
 * FILE NAME rtl_gpio.c
 *
 * BRIEF MODULE DESCRIPTION
 *  GPIO For Flash Reload Default
 *
 *  Author: jimmylin@realtek.com.tw
 *
 * Copyright 2005 Realtek Semiconductor Corp.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  either version 2 of the  License, or (at your
 *  option) any later version.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE	LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */

//#define CONFIG_USING_JTAG 1

#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/version.h>
#include <linux/interrupt.h>
#include <asm/errno.h>
#include <asm/io.h>
#include <asm/uaccess.h>
#include <linux/miscdevice.h>
#include <linux/pci.h>
#include <linux/delay.h>
#include <linux/slab.h>
#include <linux/sched.h>
#include <linux/init.h>
#include <linux/types.h>
#include <linux/reboot.h>
#include <linux/kmod.h>
#include <linux/proc_fs.h>
#include "drivers/net/rtl819x/AsicDriver/rtl865xc_asicregs.h"
#define AUTO_CONFIG

// 2009-0414
//#define	DET_WPS_SPEC
#ifndef CONFIG_RTK_VOIP_DRIVERS_ATA_DECT //DECT SPI use GPIO E interrupt, need refine code to share irq.
#ifndef CONFIG_SERIAL_SC16IS7X0 //SC16IS7x0 use GPIO E interrupt, too.  
#define USE_INTERRUPT_GPIO
#endif
#endif

#if defined(CONFIG_RTL_8196C) || defined(CONFIG_RTL_8198)
#ifndef CONFIG_RTK_VOIP
	#define READ_RF_SWITCH_GPIO
#endif
#endif

/* Foxconn added start pling 07/21/2011 */
/* Realtek patch to use interrupt for WPS PBC */
#define GPIO_INT_MASK 0xb8003000 		//GIMR		
/* Foxconn added start pling 07/21/2011 */

#define RESET_PIN_IOBASE PABCD_CNR 	//RTL_GPIO_PABCD_CNR
#define RESET_PIN_DIRBASE PABCD_DIR	//RTL_GPIO_PABCD_DIR 
#define RESET_PIN_DATABASE PABCD_DAT //RTL_GPIO_PABCD_DATA
#define RESET_PIN_NO 0 /*number of the ABCD*/
	
#define RESET_LED_IOBASE PABCD_CNR 	//RTL_GPIO_PABCD_CNR
#define RESET_LED_DIRBASE PABCD_DIR	//RTL_GPIO_PABCD_DIR 
#define RESET_LED_DATABASE PABCD_DAT //RTL_GPIO_PABCD_DATA
#define RESET_LED_NO 18 /*number of the ABCD*/
	
#define AUTOCFG_LED_IOBASE PABCD_CNR 	//RTL_GPIO_PABCD_CNR
#define AUTOCFG_LED_DIRBASE PABCD_DIR	//RTL_GPIO_PABCD_DIR 
#define AUTOCFG_LED_DATABASE PABCD_DAT //RTL_GPIO_PABCD_DATA
#define AUTOCFG_LED_NO 20 /*number of the ABCD*/

#define AUTOCFG_PIN_IOBASE PABCD_CNR 	//RTL_GPIO_PABCD_CNR
#define AUTOCFG_PIN_DIRBASE PABCD_DIR	//RTL_GPIO_PABCD_DIR 
#define AUTOCFG_PIN_DATABASE PABCD_DAT //RTL_GPIO_PABCD_DATA
#define AUTOCFG_PIN_NO 1 /*number of the ABCD)*/
#define AUTOCFG_PIN_IMR PAB_IMR
	
#define WIFI_ONOFF_PIN_IOBASE PABCD_CNR 	//RTL_GPIO_PABCD_CNR
#define WIFI_ONOFF_PIN_DIRBASE PABCD_DIR	//RTL_GPIO_PABCD_DIR 
#define WIFI_ONOFF_PIN_DATABASE PABCD_DAT //RTL_GPIO_PABCD_DATA
#define WIFI_ONOFF_PIN_NO 19/*umber of the ABCD)*/
#define WIFI_ONOFF_PIN_IMR PAB_IMR

#define RTL_GPIO_MUX 0xB8000040
#ifdef CONFIG_8198_PORT5_GMII
	#define RTL_GPIO_MUX_DATA 0x00340000
#else 
	#define RTL_GPIO_MUX_DATA 0x00340030//for WIFI ON/OFF and GPIO
#endif 
 
#define AUTOCFG_BTN_PIN         3
#define AUTOCFG_LED_PIN         7
#define RESET_LED_PIN           6
#define RESET_BTN_PIN           5 

#ifdef USE_INTERRUPT_GPIO
#ifdef CONFIG_RTK_VOIP
	#define GPIO_IRQ_NUM		(16+17)	// GPIO_EFGH
#else
	#define GPIO_IRQ_NUM		1	
	/* Foxconn added start pling 07/21/2011 */
	/* Realtek patch to use interrupt for WPS PBC */
	#define GPIO_WSC_PBC_IRQ_NUM		9	
	/* Foxconn added end pling 07/21/2011 */
#endif
#endif

#define PROBE_TIME	5
#define PROBE_NULL		0
#define PROBE_ACTIVE	1
#define PROBE_RESET		2
#define PROBE_RELOAD	3
#define RTL_R32(addr)		(*(volatile unsigned long *)(addr))
#define RTL_W32(addr, l)	((*(volatile unsigned long*)(addr)) = (l))
#define RTL_R8(addr)		(*(volatile unsigned char*)(addr))
#define RTL_W8(addr, l)		((*(volatile unsigned char*)(addr)) = (l))

static struct timer_list probe_timer;
static unsigned int    probe_counter;
static unsigned int    probe_state;
static unsigned int    wps_probe_counter;
static unsigned int    wps_probe_state;
static char default_flag='0';
int start_count_time=0;
int Reboot_Wait=0,factorytest=0;
static int wps_button_push = 0;
static unsigned int	Red_Blink=0,Red_Toggle=0,Green_Blink=0,Green_Toggle=0,Amber_Blink=0,Amber_Toggle=0,RedGreen_Blink=0,RedGreen_Toggle=0,GreenAmberBlink=0,GreenAmberToggle=0;
static unsigned long val, start;
static char GPIO_MUX_REG[]="b8000040";
static char GPIO_MUX_VALUE[]="003400f0";

static char GPIO_8196_CNR[]="b8003500";
static char GPIO_8196_DIR[]="b8003508";
static char GPIO_8196_DAT[]="b800350c";
static char GPIO_8192_CNR[]="b900004c";
static char GPIO_8192_DAT[]="b9000040";
static char LED_content1[]="0050";
static char LED_content2[]="3850";
static char LED_content3[]="00020000";

static char RED_content1[]="1068";
static char RED_content2[]="068";
static char GREEN_content1[]="04494000";
static char GREEN_content2[]="04094000";
static char GREEN_content3[]="2068";
static char GREEN_content4[]="068";
static char Amber_content[]="3068";

static char	RESET_TRUE;
static char	WPS_TRUE;

/* Foxconn added start pling 07/21/2011 */
/* Realtek patch to use interrupt for WPS PBC */
#ifdef	USE_INTERRUPT_GPIO
static int wps_button_interrput = 0;
#endif
/* Foxconn added end pling 07/21/2011 */

int catoi(char *s, int base)
{
	int k = 0;

	k = 0;
	if (base == 10) {
		while (*s != '\0' && *s >= '0' && *s <= '9') {
			k = 10 * k + (*s - '0');
			s++;
		}
	}
	else {
		while (*s != '\0') {
			int v;
			if ( *s >= '0' && *s <= '9')
				v = *s - '0';
			else if ( *s >= 'a' && *s <= 'f')
				v = *s - 'a' + 10;
			else if ( *s >= 'A' && *s <= 'F')
				v = *s - 'A' + 10;
			else {
				return 0;
			}
			k = 16 * k + v;
			s++;
		}
	}
	return k;
}

void write_mem(char *address,char *content)
{
	start = (unsigned long)catoi(address, 16);
	val = (unsigned long)catoi(content, 16);
	memcpy((char *)start, (char *)&val, 4);
}

void BlinktoStable(void)
{
	Red_Blink=Green_Blink=Amber_Blink=RedGreen_Blink=GreenAmberBlink=0;
	Red_Toggle=Green_Toggle=Amber_Toggle=RedGreen_Toggle=GreenAmberToggle=0;
}

void GpioInit(void)
{
	BlinktoStable();
	RTL_W32(RESET_PIN_IOBASE, (RTL_R32(RESET_PIN_IOBASE) & (~(1 << RESET_BTN_PIN))));
	RTL_W32(RESET_PIN_DIRBASE, (RTL_R32(RESET_PIN_DIRBASE) & (~(1 << RESET_BTN_PIN))));
	RTL_W32(AUTOCFG_PIN_IOBASE,(RTL_R32(AUTOCFG_PIN_IOBASE)&(~(1 << AUTOCFG_BTN_PIN))));
	RTL_W32(AUTOCFG_PIN_DIRBASE, (RTL_R32(AUTOCFG_PIN_DIRBASE) & (~(1 << AUTOCFG_BTN_PIN))));
	
	write_mem(GPIO_MUX_REG,GPIO_MUX_VALUE);
	write_mem(GPIO_8196_CNR,LED_content1);
	write_mem(GPIO_8196_DIR,LED_content2);
	write_mem(GPIO_8196_DAT,RED_content2);
	
	write_mem(GPIO_8192_CNR,LED_content3);
	write_mem(GPIO_8192_DAT,GREEN_content2);
}

void GPIORedOn(void)
{
	write_mem(GPIO_8196_DAT,RED_content1);
}

void GPIORedOff(void)
{
	write_mem(GPIO_8196_DAT,RED_content2);
}

void GPIOGreenOn(void)
{	
	write_mem(GPIO_8192_DAT,GREEN_content1);
	write_mem(GPIO_8196_DAT,GREEN_content3);
}

void GPIOGreenOff(void)
{
	write_mem(GPIO_8192_DAT,GREEN_content2);
	write_mem(GPIO_8196_DAT,GREEN_content4);
}

void GPIOAmberOn(void)
{
	write_mem(GPIO_8196_DAT,Amber_content);
	write_mem(GPIO_8192_DAT,GREEN_content1);
}

void GPIOAmberOff(void)
{
	write_mem(GPIO_8196_DAT,RED_content2);
	write_mem(GPIO_8192_DAT,GREEN_content2);
	write_mem(GPIO_8196_DAT,GREEN_content4);
}

/* Foxconn added start pling 07/21/2011 */
/* Realtek patch to use interrupt for WPS PBC */
unsigned int wps_pressed=0;
/* Foxconn added end pling 07/21/2011 */

static void rtl_gpio_timer(unsigned long data)
{
	unsigned int pressed=1;
	//unsigned int wps_pressed=1; /* Foxconn removed pling 07/21/2011 */
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,27)
	struct pid *pid;
#endif

	if (RTL_R32(RESET_PIN_DATABASE) & (1 << RESET_BTN_PIN))
	{
		pressed = 0;
	}

	if (probe_state == PROBE_NULL)
	{
		if (pressed)
		{
			probe_state = PROBE_ACTIVE;
			probe_counter++;
			if(factorytest==1){
				printk("Upgrading firmware, don't reboot\n");
				BlinktoStable();
				Amber_Blink =Amber_Toggle =1;
				probe_counter=0;
				probe_state=PROBE_NULL;
			}
		}
		else
			probe_counter = 0;
	}
	else if (probe_state == PROBE_ACTIVE && factorytest==0)
	{
		if (pressed)
		{
			probe_counter++;

			if (probe_counter >= PROBE_TIME)
			{
				RESET_TRUE=6;
				BlinktoStable();
				if (probe_counter & 1)
					GPIOAmberOff();
				else
					GPIOAmberOn();
			}
		}
		else
		{
			if (probe_counter < 5)
			{
				probe_state = PROBE_NULL;
				probe_counter = 0;
                /* foxconn wklin added start, 05/11/2011 */
				default_flag = '2';
                return;
                /* foxconn wklin added end, 05/11/2011 */
			}
			else if (probe_counter >= PROBE_TIME)
			{
				//reload default
				Amber_Blink=Amber_Toggle=1;
				default_flag = '1';
				return;
			}
			else
			{
			#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,27)
				kill_proc(1,SIGTERM,1);
			#else
				pid = get_pid(find_vpid(1));
				kill_pid(pid,SIGTERM,1);
			#endif
				return;
			}
		}
	}

	if (RTL_R32(AUTOCFG_PIN_DATABASE) & (1 << AUTOCFG_BTN_PIN))
	{
		//wps_pressed = 0; /* Foxconn removed pling 07/21/2011 */
		WPS_TRUE=0;
	}
	
	if (wps_probe_state == PROBE_NULL)
	{
		if (wps_pressed)
		{
			wps_probe_counter++;
			/* Foxconn removed start pling 07/21/2011 */
			/* Make WPS PBC take effect immediately */
			//if (wps_probe_counter == 3) /* delay for 1.5 seconds */
			/* Foxconn removed end pling 07/21/2011 */
			    wps_probe_state = PROBE_ACTIVE;
			if(factorytest==1){
				printk("Upgrading firmware, don't start WPS\n");
				BlinktoStable();
                GreenAmberBlink=GreenAmberToggle=1;
                wps_probe_counter=0;
                wps_probe_state = PROBE_NULL; /*Modify for make LED light faster when wps button clicked*/
			}
		}
		else
			wps_probe_counter = 0;
	}
	/* Foxconn modified start pling 07/21/2011 */
	/* Make WPS PBC take effect immediately */
	//else if (wps_probe_state == PROBE_ACTIVE && factorytest==0)
	if (wps_probe_state == PROBE_ACTIVE && factorytest==0)
	/* Foxconn modified end pling 07/21/2011 */
	{
		if (wps_pressed)
		{
			BlinktoStable();
			WPS_TRUE=5;
			if ((wps_probe_counter%4)==1)
				GPIOGreenOn();
			else if((wps_probe_counter%4)==2)
				GPIOGreenOff();
			else if((wps_probe_counter%4)==3)
			    GPIOAmberOn();
			else
			    GPIOAmberOff();
			wps_probe_counter++;
		}
		else
		{
			WPS_TRUE=5;
			BlinktoStable();
			GreenAmberBlink=GreenAmberToggle=1;
			wps_probe_state = PROBE_NULL;
		}
	}

	if (Red_Blink==1){
		GPIOGreenOff();
		if (Red_Toggle) 
			GPIORedOff();
		else 
			GPIORedOn();
		
		Red_Toggle = Red_Toggle? 0 : 1;
	}
	else if (Green_Blink==1){
		GPIORedOff();
		if (Green_Toggle) 
			GPIOGreenOff();
		else 
			GPIOGreenOn();
		
		Green_Toggle = Green_Toggle? 0 : 1;
	}
	else if (Amber_Blink==1){
		write_mem(GPIO_MUX_REG,GPIO_MUX_VALUE);
		write_mem(GPIO_8196_CNR,LED_content1);
		write_mem(GPIO_8196_DIR,LED_content2);
	
		write_mem(GPIO_8192_CNR,LED_content3);
		if (Amber_Toggle) 
			GPIOAmberOff();
		else 
			GPIOAmberOn();
		
		Amber_Toggle = Amber_Toggle? 0 : 1;
	}
	else if (RedGreen_Blink==1){
        /*Foxconn modify start by Hank for wps failure led bug 06/03/2011*/
		if (RedGreen_Toggle){
            GPIORedOff();
			GPIOGreenOn();
		}
		else{
			GPIOGreenOff();
			GPIORedOn();
		}
        /*Foxconn modify end by Hank for wps failure led bug 06/03/2011*/
		RedGreen_Toggle = RedGreen_Toggle? 0 : 1;
	/* Foxconn add start by Hank for green light and amber light blinking 05/18/2011*/
	}else if (GreenAmberBlink==1){
		if (GreenAmberToggle==1){
			GPIOGreenOn();
			GreenAmberToggle++;
		}else if(GreenAmberToggle==2){
			GPIOGreenOff();
			GreenAmberToggle++;
		}else if(GreenAmberToggle==3){
		    GPIOAmberOn();
			GreenAmberToggle++;
		}else{
		    GPIOAmberOff();
			GreenAmberToggle=1;
		}
		/* Foxconn add end by Hank for green light and amber light blinking 05/18/2011*/
        /* Foxconn add start by Hank for green light and red light blinking 06/02/2011*/
	}

	/* Foxconn added start pling 07/21/2011 */
	/* Realtek patch to use interrupt for WPS PBC */
	wps_pressed = 0;
	/* Foxconn added end pling 07/21/2011 */

	mod_timer(&probe_timer, jiffies + 50);
}

#ifdef CONFIG_RTL_FLASH_DUAL_IMAGE_ENABLE

#define SYSTEM_CONTRL_DUMMY_REG 0xb8000068

int is_bank2_root()
{
	//boot code will steal System's dummy register bit0 (set to 1 ---> bank2 booting
	//for 8198 formal chip 
	if ((RTL_R32(SYSTEM_CONTRL_DUMMY_REG)) & (0x00000001))  // steal for boot bank idenfy
		return 1;

	return 0;
}
static int read_bootbank_proc(char *page, char **start, off_t off,
				int count, int *eof, void *data)
{
	int len;
	char flag='1';

	if (is_bank2_root())  // steal for boot bank idenfy
		flag='2';
		
	len = sprintf(page, "%c\n", flag);

	if (len <= off+count) *eof = 1;
	*start = page + off;
	len -= off;
	if (len > count) len = count;
	if (len < 0) len = 0;
	return len;
}
#endif

#if defined(USE_INTERRUPT_GPIO)
static irqreturn_t gpio_interrupt_isr(int irq, void *dev_instance, struct pt_regs *regs)
{
	/* Foxconn modified start pling 07/21/2011 */
	/* Realtek patch to use interrupt for WPS PBC */
	/* wps_button_push = 1; */
	wps_button_interrput = 1;
	GPIOAmberOff();
	/* Foxconn modified end pling 07/21/2011 */

#ifdef CONFIG_RTK_VOIP
	RTL_W32(PEFGH_ISR, RTL_R32(PEFGH_ISR)); 	
#else
  	RTL_W32(PABCD_ISR, RTL_R32(PABCD_ISR)); 	
#endif
	return IRQ_HANDLED;
}
#endif

static int read_proc(char *page, char **start, off_t off,
				int count, int *eof, void *data)
{
	int len;
	char flag;

#if  defined(USE_INTERRUPT_GPIO)
// 2009-0414		 
	/* Foxconn modified start pling 07/21/2011 */
	/* Realtek patch to use interrupt for WPS PBC */
	if (wps_button_interrput) {
		flag = '1';
		wps_button_interrput = 0; 
		/*for count button pressed time please reference wps_button_push	*/
		wps_pressed = 1;
		GPIOAmberOff();
	}
	/* Foxconn modified end pling 07/21/2011 */
	else{
		if (RTL_R32(AUTOCFG_PIN_DATABASE) & (1 << AUTOCFG_BTN_PIN)){
			flag = '0';
		}else{
			flag = '1';
		}

	}
	/* Foxconn added start pling 07/21/2011 */
	/* In factory test mode, don't let WPS trigger,
	 *  by return 0 when 'wscd' read '/proc/gpio' */
	if (factorytest == 1)
		flag = '0';
	/* Foxconn added end pling 07/21/2011 */
// 2009-0414		
#else

	if (RTL_R32(AUTOCFG_PIN_DATABASE) & (1 << AUTOCFG_BTN_PIN))
		flag = '0';
	else {
		flag = '1';
	}
#endif // CONFIG_RTL865X_KLD		
	
	if(RESET_TRUE==3){
		len = sprintf(page, "%c\n", RESET_TRUE);
	}
	else if(WPS_TRUE==4){
		len = sprintf(page, "%c\n", WPS_TRUE);
	}
	else{
		len = sprintf(page, "%c\n", flag);
	}

	if (len <= off+count) *eof = 1;
	*start = page + off;
	len -= off;
	if (len > count) len = count;
	if (len < 0) len = 0;
	return len;
}



#ifdef CONFIG_RTL_KERNEL_MIPS16_CHAR
__NOMIPS16
#endif 
static int write_proc(struct file *file, const char *buffer,
				unsigned long count, void *data)
{
	char flag[20];
	char start_count[10], wait[10];
	/*if (count < 2)
		return -EFAULT;*/

	if (buffer && !copy_from_user(&flag, buffer, 1)) {
		if (flag[0] == 'E') {
			GpioInit();
		}
		else if (flag[0] == '3'){
			BlinktoStable();
			GPIORedOff();
			GPIOGreenOn();
		}
		else if (flag[0] == '5'){
			BlinktoStable();
			GPIOAmberOn();
		}
		else if (flag[0] == '6'){
			BlinktoStable();
			GPIOGreenOff();
			GPIORedOn();
		}
		else if (flag[0] == '4'){
			start_count_time= 1;
			sscanf(buffer, "%s %s", start_count, wait);
			Reboot_Wait = (simple_strtol(wait,NULL,0))*100;
		}
		else if (flag[0] == '7'){
			BlinktoStable();
			Green_Blink=Green_Toggle=1;
		}
		else if( flag[0] == '8'){
			BlinktoStable();
			Red_Blink=Red_Toggle=1;
		}
		else if( flag[0] == '9'){
			BlinktoStable();
			Amber_Blink=Amber_Toggle=1;
		}
		else if( flag[0] == 'A'){
			BlinktoStable();
			RedGreen_Blink=RedGreen_Toggle=1;
		}
		else if (flag[0] == 'B'){
			BlinktoStable();
			GPIOAmberOff();
		}else if(flag[0]=='C'){
			factorytest=1;
		}else if(flag[0]=='D'){
			factorytest=0;
		}else if( flag[0] == 'F'){
			BlinktoStable();
			GreenAmberBlink=GreenAmberToggle=1; 
         /* Foxconn add start by Hank for factory green light and red light blinking 05/18/2011*/
		}else{
		}

		return count;
	}
	else
		return -EFAULT;
}

static int default_read_proc(char *page, char **start, off_t off,
				int count, int *eof, void *data)
{
	int len;

	len = sprintf(page, "%c\n", default_flag);
	if (len <= off+count) *eof = 1;
	  *start = page + off;
	len -= off;
	if (len>count) len = count;
	if (len<0) len = 0;
	  return len;
}

#ifdef CONFIG_RTL_KERNEL_MIPS16_CHAR
__NOMIPS16
#endif 
static int default_write_proc(struct file *file, const char *buffer,
				unsigned long count, void *data)
{
	if (count < 2)
		return -EFAULT;
	if (buffer && !copy_from_user(&default_flag, buffer, 1)) {
		return count;
	}
	return -EFAULT;
}

#ifdef READ_RF_SWITCH_GPIO
static int rf_switch_read_proc(char *page, char **start, off_t off,
				int count, int *eof, void *data)
{
	int len;
	char flag;

	if (RTL_R32(WIFI_ONOFF_PIN_DATABASE) & (1<<WIFI_ONOFF_PIN_NO)){
		flag = '1';
	}else{
		flag = '0';
	}
	len = sprintf(page, "%c\n", flag);

	if (len <= off+count) *eof = 1;
	*start = page + off;
	len -= off;
	if (len > count) len = count;
	if (len < 0) len = 0;
	return len;
}
#endif

int __init rtl_gpio_init(void)
{
	struct proc_dir_entry *res=NULL;

	RTL_W32(RTL_GPIO_MUX, (RTL_R32(RTL_GPIO_MUX) | (RTL_GPIO_MUX_DATA)));
	
	RTL_W32(RESET_PIN_IOBASE, (RTL_R32(RESET_PIN_IOBASE) & (~(1 << RESET_BTN_PIN))));
	RTL_W32(RESET_PIN_DIRBASE, (RTL_R32(RESET_PIN_DIRBASE) & (~(1 << RESET_BTN_PIN))));
	RTL_W32(AUTOCFG_PIN_IOBASE, (RTL_R32(AUTOCFG_PIN_IOBASE) & (~(1 << AUTOCFG_BTN_PIN))));
	RTL_W32(AUTOCFG_PIN_DIRBASE, (RTL_R32(AUTOCFG_PIN_DIRBASE) & (~(1 << AUTOCFG_BTN_PIN))));
	
	write_mem(GPIO_MUX_REG,GPIO_MUX_VALUE);
	write_mem(GPIO_8196_CNR,LED_content1);
	write_mem(GPIO_8196_DIR,LED_content2);
	write_mem(GPIO_8196_DAT,RED_content2);
	
	write_mem(GPIO_8192_CNR,LED_content3);
	write_mem(GPIO_8192_DAT,GREEN_content2);
	Amber_Blink=Amber_Toggle=1;

#ifdef CONFIG_RTL_FLASH_DUAL_IMAGE_ENABLE	
	res = create_proc_entry("bootbank", 0, NULL);
	if (res) {
		res->read_proc = read_bootbank_proc;
	}
	else {
		printk("read bootbank, create proc failed!\n");
	}
#endif
#ifdef AUTO_CONFIG
	res = create_proc_entry("gpio", 0, NULL);
	if (res) {
		res->read_proc = read_proc;
		res->write_proc = write_proc;
	}
	else {
		printk("Realtek GPIO Driver, create proc failed!\n");
	}

// 2009-0414		
#if defined(USE_INTERRUPT_GPIO)
#if defined(CONFIG_RTL_8198) && !defined(CONFIG_RTK_VOIP)
	RTL_R32(AUTOCFG_PIN_IMR) |= (0x01 << (AUTOCFG_BTN_PIN-16)*2); // enable interrupt in falling-edge		
#else

	/* Foxconn added start pling 07/21/2011 */
	/* Realtek patch to use interrupt for WPS PBC */
	RTL_W32(GPIO_INT_MASK, RTL_R32(GPIO_INT_MASK)|(1<<9));
	/* Foxconn added end pling 07/21/2011 */
		
	RTL_R32(AUTOCFG_PIN_IMR) |= (0x01 << AUTOCFG_BTN_PIN*2); // enable interrupt in falling-edge	
#endif
	/* Foxconn modified start pling 07/21/2011 */
	/* Realtek patch to use interrupt for WPS PBC */
	if (request_irq(GPIO_WSC_PBC_IRQ_NUM, gpio_interrupt_isr, IRQF_DISABLED, "rtl_gpio", NULL)) {
		printk("gpio request_irq(%d) error!\n", GPIO_WSC_PBC_IRQ_NUM);		
   	}
	/* Foxconn modified end pling 07/21/2011 */
#endif	
#endif

	res = create_proc_entry("load_default", 0, NULL);
	if (res) {
		res->read_proc = default_read_proc;
		res->write_proc = default_write_proc;
	}

#ifdef READ_RF_SWITCH_GPIO
	res = create_proc_entry("rf_switch", 0, NULL);
	if (res) {
		res->read_proc = rf_switch_read_proc;
		res->write_proc = NULL;
	}
#endif

	init_timer(&probe_timer);
	probe_counter = 0;
	probe_state = PROBE_NULL;
	wps_probe_state = PROBE_NULL;
	probe_timer.expires = jiffies + 50;
	probe_timer.data = (unsigned long)NULL;
	probe_timer.function = &rtl_gpio_timer;
	mod_timer(&probe_timer, jiffies + 50);

	return 0;
}


static void __exit rtl_gpio_exit(void)
{
	printk("Unload Realtek GPIO Driver \n");
	del_timer_sync(&probe_timer);
}


module_exit(rtl_gpio_exit);
module_init(rtl_gpio_init);

MODULE_LICENSE("GPL");
MODULE_DESCRIPTION("GPIO driver for Reload default");
