/***************************************************************************
***
***    Copyright 2005  Hon Hai Precision Ind. Co. Ltd.
***    All Rights Reserved.
***    No portions of this material shall be reproduced in any form without the
***    written permission of Hon Hai Precision Ind. Co. Ltd.
***
***    All information contained in this document is Hon Hai Precision Ind.  
***    Co. Ltd. company private, proprietary, and trade secret property and 
***    are protected by international intellectual property laws and treaties.
***
****************************************************************************/

#ifndef AMBIT_UTIL_H
#define AMBIT_UTIL_H

#include <sys/socket.h>
#include <netinet/in.h>

#ifndef EQ
#define EQ ==
#endif

#ifndef NEQ
#define NEQ !=
#endif

#ifndef MINVAL
#define MINVAL(a, b) ((a) < (b) ? (a) : (b))
#endif

#ifndef BOOL
#define BOOL    int
#endif

/* Debug print */
#ifdef DEBUG
#define dprintf(fmt, args...) printf("%s: " fmt, __FUNCTION__, ## args)
#else
#define dprintf(fmt, args...)
#endif

/* Return NUL instead of NULL if undefined */
#define safe_getenv(s) (getenv(s) ? : "")

/*
 * Concatenate two strings together into a caller supplied buffer
 * @param	s1	first string
 * @param	s2	second string
 * @param	buf	buffer large enough to hold both strings
 * @return	buf
 */
static inline char * strcat_r(const char *s1, const char *s2, char *buf)
{
	strcpy(buf, s1);
	strcat(buf, s2);
	return buf;
}	

extern char * inet_ntoa_b(struct in_addr ina, char *buf);
extern void convert2upper(char * strPtr, int strLen);
extern char *itoa(unsigned int i);
extern void strlwr(char *String);
extern int strnicmp (char *s1, char *s2, int n);
extern int stricmp (char *s1, char *s2);
extern char *base64enc (const char *p, char *buf, int len);
extern void base64decode (char *string);
extern int base64val (char c);
extern char *stristr (const char *a, const char *b);

extern int getTokens(char *str, char *delimiter, char token[][], int maxNumToken);
extern int isValidIpAddr(char *ipAddr);
extern int isValidNetworkAddr(char *ipAddr);
extern int isValidNetmask(char *mask);
extern int isLanSubnet(char *ipAddr);
#ifdef WLAN_REPEATER
/* add by Foxconn Michael for network device */
extern int isBRSubnet(char *ipAddr);
#endif
/* Foxconn add start, Max Ding, 10/31/2008 for @RU_two_wan */
#ifdef STATIC_PPPOE
extern int isSecWanSubnet(char *ipAddr);
#endif
/* Foxconn add end, Max Ding, 10/31/2008 */
extern int isWanSubnet(char *ipAddr);
extern int isNumber(char *str);
extern int isHexDigit(char c);
extern int isHexString(char *str);
extern int isValidMacAddr(char *macAddr);
extern void trimMacAddr(char *macAddr);
extern void formatMacAddr(char *macAddr);
extern void strToLower(char *str);
extern void strToUpper(char *str);
extern int cliStr2NumCheck(char *string, int lower, int upper);
extern void HexToAscii (char *hexKey, char *asciiKey);

extern int ether_atoe(const char *a, unsigned char *e);
extern char *ether_etoa(const unsigned char *e, char *a);

extern unsigned long calculate_checksum (int action, char *s, int size);
extern unsigned short hd_cksum(unsigned short *addr, int len);

/* Foxconn added start Bob Guo 11/14/2006 */
extern int ambitWriteLog(char *pcLog, int iLen);
/* Foxconn added end Bob Guo 11/14/2006 */

#endif
