#include <stdlib.h>
#include <stdio.h>
#include <mtd/mtd-user.h>
#include "lang.h"
#include "version.h" 
#include "apmib.h"
#include "apform.h"
#include "ambitCfg.h"
#include "../md5.h" 

char TargetLang[MAX_LANG_TBL_LANG_TAG_LEN] = {0};
char CurrentLang[MAX_LANG_TBL_LANG_TAG_LEN] = {0};
char SelectLang[MAX_LANG_TBL_LANG_TAG_LEN] = {0};
extern char current_host[100];/*added by dennis, fxcn,07/12/2011, record current_ftp_host*/
int LangCheckAction = LANG_CHECK_ACTION_NONE;
int currentLangFtpcStatus = FTPC_LANG_GET_NONE;/* Foxconn modified by Max Ding, 05/11/2010 */
int gFtpcGetLangCfgStatus = FTPC_STATUS_LANG_CFG_NONE;
int gFtpcGetLangTblStatus = FTPC_STATUS_LANG_TBL_NONE;
int gWriteLangTbl2FlashStatus = FTPC_STATUS_WRITE_LANG_TBL_NONE;

LatestLangTblVersionInfo_t gLangTblVerionInfo = {"", "", "", "", 0};
LatestLangTblVersionInfo_t langTblVersionInfo = {"", "", "", "", 0};
extern LatestLangTblVersionInfo_t langTblVerInfo;
extern LatestLangTblVersionInfo_t gLangTblVerionInfo;
extern LatestLangTblVersionInfo_t langTblVersionInfo;

extern int ftp_process;
char productName[MAX_BOARDID_LEN];
extern char applyLang[16];

extern strTbl_t strTblMtd[ST_SUPPORT_NUM]; /* Foxconn Caelia Su added 2011/06/14 */
extern char *FSfiles[5]; /* Foxconn Caelia Su added 2011/06/14 */
extern char fw_country_code[6]; /* Foxconn Caelia Su added 2011/06/15 */

char newLangTblVerStr[MAX_LANG_TBL_VER_STR_LEN] = {0}; /* Foxconn Caelia Su added 2011/06/14 */
char currLangTblVerStr[MAX_LANG_TBL_VER_STR_LEN] = {0}; /* Foxconn Caelia Su added 2011/06/14 */
char lang[16];

int parseLangTblFileTag (char *pStr, char *tag, unsigned int tag_len)
{
    char *ptr_start = NULL;
    char *ptr_end = NULL;
    unsigned int copy_len = 0;
    char prefix[MAX_LANG_TBL_FILENAME_LEN] = "";

    if ((!pStr) || (!tag) || (tag_len <= 0))
        return ERROR;

    sprintf (prefix, "%s-", productName);
    if (!(ptr_start = stristr(pStr, prefix)))
    {
        return ERROR;
    }
    ptr_start += strlen(prefix);
    if (!(ptr_end = stristr(ptr_start, "-language-table]")))
    {
        return ERROR;
    }

    copy_len = abs(ptr_end - ptr_start);
    if (copy_len > tag_len)
    {
        printf("Lang_tag is too long,strip it!\n");
        copy_len = tag_len;
    }

    strncpy (tag, ptr_start, copy_len);
    tag[copy_len] = '\0';
    trimstr (tag, copy_len);
    
    printf("Tag:%s\n", tag);
    return OK;
}

int parseLangTblFileNameVer (char *pStr, char *filename,
                            char *ver, unsigned int filename_len, unsigned int ver_len)
{
    char *ptr_start = NULL;
    char *ptr_end = NULL;
    unsigned int copy_len = 0;
    char prefix[MAX_LANG_TBL_FILENAME_LEN] = "";
    
    if ((!pStr) || (!filename) || (filename_len <= 0))
        return ERROR;
    if (!stristr(pStr, "file="))
    {
        return ERROR;
    }

    ptr_start = pStr + strlen("file=");
    copy_len = strlen (ptr_start);
    if (copy_len > filename_len)
    {
        printf("Lang_filename is too long,strip it!\n");
        copy_len = filename_len;
    }

    strncpy (filename, ptr_start, copy_len);
    filename[copy_len] = '\0';
    trimstr (filename, copy_len);

    sprintf (prefix, "%s-V", productName);
    if (!stristr(ptr_start, prefix))
    {
        return ERROR;
    }
    ptr_start = stristr(ptr_start, prefix) + strlen(prefix);
    if (!(ptr_end = strrchr(ptr_start, '.')))
        return ERROR;

    ptr_end ++;
    while( ptr_end && *ptr_end >= '0' && *ptr_end <= '9')
        ptr_end ++;

    copy_len = abs(ptr_end - ptr_start);
    if (copy_len > ver_len)
    {
        printf("Lang_ver is too long,strip it!\n");
        copy_len = ver_len;
    }

    strncpy (ver, ptr_start, copy_len);
    ver[copy_len] = '\0';
    trimstr (ver, copy_len);

    printf("Filepath:%s\n", filename);
    printf("Version:%s \n", ver); 
    return OK;
}

int parseLangTblFileMD5(char *pStr, char *md5, unsigned int md5_len)
{
    char *ptr_start = NULL;
    unsigned int copy_len = 0;
    
    if ((!pStr) || (!md5) || (md5_len <= 0))
        return ERROR;
    if (!(ptr_start = stristr(pStr, "md5=")))
    {
        return ERROR;
    }

    ptr_start += strlen("md5=");

    copy_len = strlen (ptr_start);
    if (copy_len > md5_len)
    {
        printf("Lang_md5 is too long,strip it!\n");
        copy_len = md5_len;
    }

    strncpy (md5, ptr_start, copy_len);
    md5[copy_len] = '\0';
    trimstr (md5, copy_len);
    
    printf("MD5:%s\n", md5);
    return OK;
}

int parseLangTblFileSize(char *pStr, char *size, unsigned int size_len)
{
    char *ptr_start = NULL;
    unsigned int copy_len = 0;
    
    if ((!pStr) || (!size) || (size_len <= 0))
        return ERROR;
    if (!(ptr_start = stristr(pStr, "size=")))
    {
        return ERROR;
    }

    ptr_start += strlen("size=");

    copy_len = strlen (ptr_start);
    if (copy_len > size_len)
    {
        printf("Lang_size is too long,strip it!\n");
        copy_len = size_len;
    }

    strncpy (size, ptr_start, copy_len);
    size[copy_len] = '\0';
    trimstr (size, copy_len);
    
    printf("Size:%s\n", size);
    return OK;
}

unsigned char cat2HexNumTochar(char first, char second)
{
    unsigned char a;
    unsigned char b;
    char result;
    
    if (first >= 0x61 && first <= 0x7a)
        a = first - 0x57;
    else 
        a = first - 0x30;
    if (second >= 0x61 && second <= 0x7a)
        b = second - 0x57;
    else
        b = second - 0x30;

    //printf("a=%d, b=%d\n", a, b);
    a = a << 4;
    result = a + b;
    return result;
}

void latestLangTblVersionInfo_init (LatestLangTblVersionInfo_t
                                               *pLangTblVerInfo)
{
    if (!pLangTblVerInfo)
        return;

    pLangTblVerInfo->langtag[0] = '\0';
    pLangTblVerInfo->filename[0] = '\0';
    pLangTblVerInfo->version[0] = '\0';
    pLangTblVerInfo->md5[0] = '\0';
    pLangTblVerInfo->fileSize = 0L;
}

static int langCheckLangTbl(unsigned long file_size,
                                    unsigned char * file_md5)
{
    if((file_size == gLangTblVerionInfo.fileSize)
       &&(strcmp(file_md5, gLangTblVerionInfo.md5) == 0))
          //&& (file_md5 == gLangTblVerionInfo.md5))
        return OK;

#ifdef CHECK_SIZE_MD5
    return ERROR;
#endif
    return OK;
}

int trimstr (char *str, unsigned int str_len)
{
    char *start = NULL;
    char *end = NULL;
    
    if ((!str) || (str_len <= 0))
        return ERROR;

    start = str;
    end = start + str_len - 1;

    while (isspace(*start) || islf(*start) || iscr(*start))
    {
        *start = '\0';
        start++;
    }

    while (isspace(*end) || islf(*end) || iscr(*end))
    {
        *end = '\0';
        end--;
    }

    if (start <= end)
        strncpy(str, start, abs(end - start) + 1);
    else
        strcpy(str, "");

    return OK;
}

int parseLatestLangTblVersionInfo (FILE *fd_lang_cfg, char *lang_name,
        LatestLangTblVersionInfo_t *pLangTblVerInfo)
{
    char searchTag[MAX_BYTE_PER_LINE] = {0};
    char LangTag[MAX_LANG_TBL_LANG_TAG_LEN] = {0};
    char Filename[MAX_LANG_TBL_FILENAME_LEN] = {0};
    char Version[MAX_LANG_TBL_VER_STR_LEN] = {0};
    unsigned char MD5[MAX_LANG_TBL_MD5_STR_LEN] = {0};
    char Size[MAX_LANG_TBL_SIZE_STR_LEN] = {0};
    char line_buf[MAX_BYTE_PER_LINE] = {0};
    int foundFlag = 0;
    int i = 0;
    int j = 0;

    if ((!pLangTblVerInfo) || (!fd_lang_cfg))
        return ERROR;

    /* Foxconn modified start, zacker, 08/03/2007 */
    memset(productName, '\0', sizeof(productName));
    strcpy(productName, AMBIT_PRODUCT_NAME);

    /* modify by Antony 01/03/11 for NEWGUI string Upgrade mechanism */
    sprintf(searchTag, "[%s-%s-language-table]", productName, lang_name);
    /*
    sprintf(searchTag, "[%s-NEWGUI-%s-language-table]", productName, lang_name);
    */

printf("searchTag %s\n", searchTag);
    while (fgets(line_buf, MAX_BYTE_PER_LINE - 1, fd_lang_cfg))
    {
        if (stristr(line_buf, searchTag))
            foundFlag++;

        if (foundFlag)
        {
            /* break if the content is not complete */
            if(stristr(line_buf, "-language-table]") && (!stristr(line_buf, searchTag)))
                break;

            parseLangTblFileTag(line_buf, LangTag, MAX_LANG_TBL_LANG_TAG_LEN - 1);
            parseLangTblFileNameVer(line_buf, Filename, Version,
                    MAX_LANG_TBL_FILENAME_LEN - 1, MAX_LANG_TBL_VER_STR_LEN - 1);
            //parseLangTblVersion(line_buf, Version, MAX_LANG_TBL_VER_STR_LEN - 1);
            parseLangTblFileMD5(line_buf, MD5, MAX_LANG_TBL_MD5_STR_LEN - 1);
            parseLangTblFileSize(line_buf, Size, MAX_LANG_TBL_SIZE_STR_LEN - 1);
        }
    }

    if( (strlen(LangTag) == 0)
     || (strlen(Filename) == 0)
     || (strlen(Version) == 0)
#ifdef CHECK_SIZE_MD5
     || (strlen(MD5) == 0)
     || (strlen(Size) == 0)
#endif
      )
    {
        printf ("Content of the LatestVersion file is invalid.\n");
        return ERROR;
    }
    strncpy (pLangTblVerInfo->langtag, LangTag, MAX_LANG_TBL_LANG_TAG_LEN - 1);
    strncpy (pLangTblVerInfo->filename, Filename, MAX_LANG_TBL_FILENAME_LEN - 1);
    strncpy (pLangTblVerInfo->version, Version, MAX_LANG_TBL_VER_STR_LEN - 1);

    //TODO: convertion error protection
    if (strlen(MD5) == 0)
    strcpy(pLangTblVerInfo->md5, "");
    //pLangTblVerInfo->md5= 0L;
    else
    {
        strToLower(MD5);
        //printf("MD5MD5MD5MD5MD5 %s\n", MD5);
        while (i <= 31)
        {
            pLangTblVerInfo->md5[j] = cat2HexNumTochar(MD5[i], MD5[i+1]);
            printf("%02x ", pLangTblVerInfo->md5[j]);
            i += 2;
            j++;
        }
    }
    if (strlen(Size) == 0)
        pLangTblVerInfo->fileSize = 0L;
    else
    {
        sscanf (Size, "%lu", &(pLangTblVerInfo->fileSize));
    }

    return OK;
}


int getLangTblVersion (LatestLangTblVersionInfo_t *langTblVersionInfo,
                                  char *version, int version_len)
{
    if((!version) || (version_len <= 0) || (!langTblVersionInfo))
        return ERROR;
    
    if (langTblVersionInfo &&
        langTblVersionInfo->version &&
        langTblVersionInfo->langtag &&
        langTblVersionInfo->filename)
    {
        strncpy(version, langTblVersionInfo->version, version_len);
        return OK;
    }
    //printf("debug version is %s\n", version);
    return ERROR;
}

int isLangTblLatest (LatestLangTblVersionInfo_t * langTblVersionInfo)
{
    /* Foxconn Caelia Su marked start 2011/06/13 */
    /* Change these two variables to global variables and fmmgmt.c can use them. */
    /* char newLangTblVerStr[MAX_LANG_TBL_VER_STR_LEN] = {0};
    char currLangTblVerStr[MAX_LANG_TBL_VER_STR_LEN] = {0}; */
    /* Foxconn Caelia Su marked end 2011/06/13 */
    int newVersion[LANG_TBL_VER_STR_DIGIT_NUM] = {0};
    int currVersion[LANG_TBL_VER_STR_DIGIT_NUM] = {0};
    int i = 0;
    int curr_digit_num = 0;
    int new_digit_num = 0;
    char lang_path[64]; /* Foxconn Caelia Su marked 2011/06/14 */

    /* Foxconn add start, Tony W.Y. Wang, 04/02/2010 */
#ifdef SINGLE_FIRMWARE
    /*char mtd_lang_name[NVRAM_PARAM_NAME_LEN] = {0};
    char mtd_lang_version[MAX_LANG_TBL_VER_STR_LEN] = {0};*/
    int mtd_ML1_lang_tbl_ver[LANG_TBL_VER_STR_DIGIT_NUM] = {0};
    int mtd_ML_index = 0;
    int j = 0;
    int mtd_ML_lang_tbl_max_ver[LANG_TBL_VER_STR_DIGIT_NUM] = {0,0,0,0,0,0,0,0};
#endif
    /* Foxconn add end, Tony W.Y. Wang, 04/02/2010 */

    if (getLangTblVersion (langTblVersionInfo, newLangTblVerStr,
                            MAX_LANG_TBL_VER_STR_LEN - 1) != OK)
        return FALSE;

    if (strlen(TargetLang) == 0)
        return FALSE;

    /* Foxconn add start, Tony W.Y. Wang, 04/02/2010 */
#ifdef SINGLE_FIRMWARE
    if (stricmp(TargetLang, BUILTIN_LANGUAGE) == 0)
    {
        /* Foxconn Caelia Su modified start 2011/06/14 */
        /* sprintf (currLangTblVerStr, "%s", acosNvramConfig_get("str_tbl_en_ver")); */
        sprintf(lang_path, "/tmp/WNDR"); 
        getStrTblVerLangfromFile(lang_path, currLangTblVerStr, TargetLang);
        /* Foxconn Caelia Su modified end 2011/06/14 */
    }
    else if (LangCheckAction != LANG_CHECK_ACTION_NONE)
    {
        for (i = LANG_TBL_MTD_START; i < (LANG_TBL_MTD_START + ST_SUPPORT_NUM); i++)
        {
            /* Foxconn Caelia Su modified 2011/06/14 */
            /*
            sprintf(mtd_lang_name, "mtd%d_lang_name", i);
            sprintf(mtd_lang_version, "mtd%d_lang_version", i);      
            */
            /* if(strcmp(TargetLang, acosNvramConfig_get(mtd_lang_name)) == 0) */
            if(strcmp(TargetLang, strTblMtd[i].lang) == 0)
            {
                /* Foxconn Caelia Su modified start 2011/06/14 */
                sprintf(lang_path, "/tmp/WNDR");
                getStrTblVerLangfromFile(lang_path, currLangTblVerStr, TargetLang);
                /* sscanf(acosNvramConfig_get(mtd_lang_version), "%d.%d.%d.%d_%d.%d.%d.%d", &mtd_ML1_lang_tbl_ver[0], */
                sscanf(currLangTblVerStr, "%d.%d.%d.%d_%d.%d.%d.%d", &mtd_ML1_lang_tbl_ver[0],
                   &mtd_ML1_lang_tbl_ver[1], &mtd_ML1_lang_tbl_ver[2], &mtd_ML1_lang_tbl_ver[3],
                   &mtd_ML1_lang_tbl_ver[4], 
                   &mtd_ML1_lang_tbl_ver[5], &mtd_ML1_lang_tbl_ver[6], &mtd_ML1_lang_tbl_ver[7]);
                /* Foxconn Caelia Su modified end 2011/06/14 */

                for (j = 0; j < LANG_TBL_VER_STR_DIGIT_NUM; j++)
                {
                    if (mtd_ML_lang_tbl_max_ver[j] > mtd_ML1_lang_tbl_ver[j])
                        break;
                    else if (mtd_ML_lang_tbl_max_ver[j] == mtd_ML1_lang_tbl_ver[j])
                        continue;
                    else if (mtd_ML_lang_tbl_max_ver[j] < mtd_ML1_lang_tbl_ver[j])
                    {
                        mtd_ML_index = i;
                        /* Foxconn Caelia Su modified 2011/06/14 */
                        /* sprintf(currLangTblVerStr, "%s", acosNvramConfig_get(mtd_lang_version)); */
                        memcpy(mtd_ML_lang_tbl_max_ver, mtd_ML1_lang_tbl_ver, sizeof(mtd_ML_lang_tbl_max_ver));
                    }
                }
            }
        }
        if (mtd_ML_index == 0)
        {
            sprintf(currLangTblVerStr, "%s", "0.0.0.0_0.0.0.0"); 
        }
    }
    else
    {
        return FALSE;
    }
#else
#ifdef X_ST_ML
    if (stricmp(TargetLang, BUILTIN_LANGUAGE) != 0 && stricmp(TargetLang, CurrentLang) != 0)
#else
    if (stricmp(TargetLang, LANG_ENGLISH) != 0 && stricmp(TargetLang, CurrentLang) != 0)
#endif
        return TRUE;

#ifdef X_ST_ML
    if (stricmp(TargetLang, BUILTIN_LANGUAGE) == 0)
#else
    if (stricmp(TargetLang, LANG_ENGLISH) == 0)
#endif
        /* Foxconn Caelia Su marked 2011/06/14 */
        /* sprintf (currLangTblVerStr, "%s", acosNvramConfig_get("str_tbl_en_ver")); */
    else
    {
        if (LangCheckAction != LANG_CHECK_ACTION_NONE)
            /* Foxconn Caelia Su marked 2011/06/14 */
            /* sprintf (currLangTblVerStr, "%s", acosNvramConfig_get("str_tbl_non_en_ver")); */
        else
            return FALSE;
    }
#endif
    /* Foxconn add end, Tony W.Y. Wang, 04/02/2010 */

    /*added by dennis start,foxconn,07/11/2011,check version in all language*/
    sprintf(lang_path, "/tmp/WNDR");        
    getStrTblVerLangfromFile(lang_path, currLangTblVerStr, TargetLang);  
    /*added by dennis end,foxconn,07/11/2011,check version in all language*/
    /*foxconn add start, water, 07/21/2009*/
    curr_digit_num = sscanf (currLangTblVerStr, "%d.%d.%d.%d_%d.%d.%d.%d", &currVersion[0],
            &currVersion[1], &currVersion[2], &currVersion[3], 
            &currVersion[4], &currVersion[5], &currVersion[6], &currVersion[7]);

    new_digit_num = sscanf (newLangTblVerStr, "%d.%d.%d.%d_%d.%d.%d.%d", &newVersion[0],
            &newVersion[1], &newVersion[2],&newVersion[3],
            &newVersion[4], &newVersion[5], &newVersion[6], &newVersion[7]);

    if  (  ((curr_digit_num == 4))
        && (new_digit_num == LANG_TBL_VER_STR_DIGIT_NUM)
        )
        return TRUE;
    /*foxconn add end, water, 07/21/2009*/

    if ((curr_digit_num != LANG_TBL_VER_STR_DIGIT_NUM) ||
        (new_digit_num != LANG_TBL_VER_STR_DIGIT_NUM))
    {
        printf("Incorrect LangTbl Version format!\n");
        return FALSE;
    }

    for (i = 0; i < LANG_TBL_VER_STR_DIGIT_NUM; i++)
    {
        if (newVersion[i] > currVersion[i])
            return TRUE;
        else if (newVersion[i] == currVersion[i])
            continue;
        else
            return FALSE;
    }

    return FALSE;
}

int lang_WriteLangTblToFlashStatus(void)
{
    return (gWriteLangTbl2FlashStatus);
}

int lang_WriteLangTblToFlash ()
{
    FILE *fp;
    int file_size, result;
    char *read_data;

    gWriteLangTbl2FlashStatus = FTPC_STATUS_WRITE_LANG_TBL_IN_PROGRESS;
    fp = fopen(PATHNAME_LANG_TBL, "r");
    if (fp) {
        fseek(fp, 0, SEEK_END);
        file_size = ftell(fp);
        fseek(fp, 0, SEEK_SET);
        read_data = (unsigned char*)malloc(file_size);
        fread(read_data, sizeof(unsigned char), file_size, fp);
        fclose(fp);
        if (!read_data){
            gWriteLangTbl2FlashStatus = FTPC_STATUS_WRITE_LANG_TBL_FAIL;
            return 0;
        }
        result = updateStrTbl2Flash(read_data, file_size); /* upgrade string table */
        free(read_data);
        if (strlen(applyLang) != 0)
            strcpy(lang, applyLang);
        if (result == 1) {
            gWriteLangTbl2FlashStatus = FTPC_STATUS_WRITE_LANG_TBL_OK;
            Reload_Hashtable(TargetLang);
            return OK;
        }
        gWriteLangTbl2FlashStatus = FTPC_STATUS_WRITE_LANG_TBL_FAIL;
        return 0;
    }
    return 0;
}

int ftpc_LangReadErrorCode (void)
{
    FILE *ftpcErr_fp;
    char szID[8];
    int err = -1;

    if (ftpcErr_fp = fopen (FTPC_ERROR_CODE_FILE, "r"), ftpcErr_fp)
    {
        fread (szID, 8, 1, ftpcErr_fp);
        err = atoi (szID);
        fclose (ftpcErr_fp);
    }
    return err;
}

static int ftpc_LangGetError (int errorCode)
{
    int errbase = 0x00, ret;

    if (currentLangFtpcStatus == FTPC_LANG_GET_TBL)
        errbase = 0x10;

    switch (errorCode)
    {
    case FTPC_ERR_NONE:
        ret = FTPC_STATUS_LANG_CFG_NONE + errbase;
        break;
    case FTPC_ERR_DNS_RESOLER_UPDATE:
    case FTPC_ERR_DNS_RESOLE_FAIL:
    case FTPC_ERR_HOOKUP_FAIL:
        ret = FTPC_STATUS_LANG_CFG_CANNOT_CONNECT_SVR + errbase;
        break;
    case FTPC_ERR_GET_FILE_FAIL:
        ret = FTPC_STATUS_LANG_CFG_GET_FAIL + errbase;
        break;
    case FTPC_ERR_BUFFER_OVERFLOW:
        ret = FTPC_STATUS_LANG_CFG_NO_MEMORY + errbase;
        break;
    case FTPC_ERR_ABORT_BY_USER:
        ret = FTPC_STATUS_LANG_CFG_ABORT_BY_USER + errbase;
        break;
    case FTPC_ERR_READ_TIMEOUT:
        ret = FTPC_STATUS_LANG_CFG_INVALID + errbase;
        break;

    case FTPC_ERR_LOGIN_FAIL:
        ret = FTPC_STATUS_LANG_TBL_LOGIN_FAIL;
        break;
    case FTPC_ERR_FILE_UNAVAILABLE:
        ret = FTPC_STATUS_LANG_CFG_FILE_UNAVAILABLE + errbase;
        break;
    case FTPC_ERR_FAIL_EXIT:
        ret = FTPC_STATUS_LANG_CFG_FAIL_EXIT + errbase;
        break;
    case FTPC_ERR_OTHERS:
    default:
        ret = FTPC_STATUS_LANG_CFG_OTHER + errbase;
        break;
    }

    return ret;
}


static int calculateFileMD5(FILE *fd, unsigned char *md5)
{
    MD5_CONTEXT md5_lang;
    unsigned long filesize;
    char *dataBuf;
    int i = 0;
    int j = 0;
    unsigned char digest[16] = "";

    calculateFileSize(fd, &filesize);
    dataBuf = malloc(filesize+1);
    i = fread(dataBuf, 1, filesize, fd);

    MD5Init(&md5_lang); 
    MD5Update(&md5_lang, (unsigned char *)dataBuf, i);
    MD5Final(&digest[0], &md5_lang); 

    printf("md5 result:\n");
    for(i = 0; i <= 15; i++)
       printf("%02x ", digest[i]);
    printf("\n");

    while(j <= 15)
    {
        if(digest[j] ==  gLangTblVerionInfo.md5[j])
            j++;
        else
        {
            printf("Check md5 failed!\n");
            free(dataBuf);
            return ERROR;
        }
    }
    printf("caculate MD5 Matched!\n");
    free(dataBuf);
    return OK;
}

int ftpc_LangGotFile (void)
{
    FILE *fp = NULL;
    char dataBuf[SIZE_CFGFILE] = "";
    char ascBuf[SIZE_CFGFILE] = "";
    int size = 0;
    unsigned long filesize = 0;
    unsigned char lang_tbl_md5[MAX_MD5_LEN] = "";
    LatestLangTblVersionInfo_t langTblVerInfo = {"", "", "", "", 0};
    char pathname[C_MAX_VAR_SIZE] = {0};
    int status = FTPC_STATUS_LANG_CFG_NONE;
    int errorcode = FTPC_ERR_NONE;
    static unsigned int lang_TryTime = 1;

    printf("In ftpc_LangGotFile!\n");
    if (currentLangFtpcStatus == FTPC_LANG_GET_CFG)
    {
        strncpy (pathname, PATHNAME_LANG_CFG, C_MAX_VAR_SIZE - 1);
    }
    else if (currentLangFtpcStatus == FTPC_LANG_GET_TBL)
    {
        strncpy (pathname, PATHNAME_LANG_TBL, C_MAX_VAR_SIZE - 1);
    }
    else
    {
        status = ftpc_LangGetError (FTPC_ERR_OTHERS);
        goto end;
    }

    /* foxconn modified start, zacker, 04/21/2010 */
    errorcode = ftpc_LangReadErrorCode ();

    if((errorcode >= FTPC_ERR_DNS_RESOLER_UPDATE)
       && (errorcode <= FTPC_ERR_OTHERS))
    {
        if (lang_TryTime < 3)
        {
            lang_TryTime++;
            printf ("try_times:%d,errorcode:0x%x\n", lang_TryTime, errorcode);

            if (currentLangFtpcStatus == FTPC_LANG_GET_CFG)
            {
                ftpc_LangSendGetLangCfgCmd (1, FTPC_STATUS_LANG_CFG_IN_PROGRESS);
                status = FTPC_STATUS_LANG_CFG_IN_PROGRESS;
            }
            else if (currentLangFtpcStatus == FTPC_LANG_GET_TBL)
            {
                /* gLangTblVerionInfo should be there if in FTPC_LANG_GET_TBL stage */
                ftpc_LangSendGetLangTblCmd (&gLangTblVerionInfo);
                status = FTPC_STATUS_LANG_TBL_IN_PROGRESS;
            }
            else
            {
                lang_TryTime = 1;
                status = ftpc_LangGetError (FTPC_ERR_OTHERS);
            }
        }
        else
        {
            lang_TryTime = 1;
            status = ftpc_LangGetError (errorcode);
        }

        goto end;
    }
    else
    {
        lang_TryTime = 1;
        status = ftpc_LangGetError (errorcode);
    }

    /* Check retry before this, since even if "pathname" exists,
     * it may be a corrupt/uncomplete file. And there should be
     * a errorcode if "pathname" doesn't exists.
     */
    if (!(fp = fopen (pathname, "r")))
    {
        printf ("%s: no files!\n", pathname);
        status = ftpc_LangGetError (FTPC_ERR_GET_FILE_FAIL);
        goto end;
    }
    /* foxconn modified end, zacker, 04/21/2010 */
    else
    {
        if ((calculateFileSize(fp,&filesize) != OK))
        {
            status = ftpc_LangGetError (FTPC_ERR_GET_FILE_FAIL);
            goto end;
        }
        if (filesize <= 0)
        {
            status = ftpc_LangGetError (FTPC_ERR_GET_FILE_FAIL);
            goto end;
        }
        rewind(fp);

        if (currentLangFtpcStatus == FTPC_LANG_GET_CFG)
        {
            size = fread(dataBuf, 1, SIZE_CFGFILE, fp);
            fclose(fp);
            size = unicode_file_to_ascii_str(ascBuf, SIZE_CFGFILE, dataBuf, size);
            fp = fopen("/tmp/tmpfile", "w");
            fprintf(fp, "%s\n", ascBuf);
            fclose(fp);
            fp = fopen("/tmp/tmpfile", "r");

            latestLangTblVersionInfo_init (&langTblVerInfo);
            if (OK == parseLatestLangTblVersionInfo (fp, TargetLang, &langTblVerInfo))
            {
                memcpy (&gLangTblVerionInfo, &langTblVerInfo, sizeof (LatestLangTblVersionInfo_t));
                status = FTPC_STATUS_LANG_CFG_OK;
            }
            else
            {
                memset (&gLangTblVerionInfo, 0, sizeof (LatestLangTblVersionInfo_t));
                status = FTPC_STATUS_LANG_CFG_INVALID;
                goto end;
            }
        }
        else if (currentLangFtpcStatus == FTPC_LANG_GET_TBL)
        {
            if (calculateFileMD5 (fp, lang_tbl_md5) != OK)
            {
                status = FTPC_STATUS_LANG_TBL_INVALID;
                goto end;
            }

            if (langCheckLangTbl(filesize, lang_tbl_md5) == OK)
            {
                status = FTPC_STATUS_LANG_TBL_OK;
            }
            else
            {
                status = FTPC_STATUS_LANG_TBL_INVALID;
                goto end;
            }
        }
        else
        {
            status = ftpc_LangGetError (FTPC_ERR_GET_FILE_FAIL);
            goto end;
        }
    }
end:
    if (fp)
    {
        fclose (fp);
        fp = NULL;
    }

    if (currentLangFtpcStatus == FTPC_LANG_GET_CFG)
    {
        gFtpcGetLangCfgStatus = status;
    }
    else if (currentLangFtpcStatus == FTPC_LANG_GET_TBL)
    {
        gFtpcGetLangTblStatus = status;
    }
    else
    {
        gFtpcGetLangCfgStatus = status;
        gFtpcGetLangTblStatus = status;
    }
    return status;
}

int ftpc_LangGetLangTblFileStatus (void)
{
    return gFtpcGetLangTblStatus;
}

int ftpc_LangGetLangConfigFileStatus (LatestLangTblVersionInfo_t *pLangTblVerInfo)
{
    int status = gFtpcGetLangCfgStatus;
    if (!pLangTblVerInfo)
        return (FTPC_STATUS_LANG_CFG_GET_FAIL);
    latestLangTblVersionInfo_init (pLangTblVerInfo);
    if (FTPC_STATUS_LANG_CFG_OK == gFtpcGetLangCfgStatus)
        memcpy (pLangTblVerInfo, &gLangTblVerionInfo, sizeof (LatestLangTblVersionInfo_t));
    return (status);
}

void ftpc_LangSendGetLangCfgCmd (int serverIndex, int ftpcStatus)
{
    char command[C_MAX_VAR_SIZE] = {0};
    char product_name[MAX_PRODUCT_NAME_LEN] = {0};
    char host[100] = "", userName[10] = "", password[20] = "";

    ftp_process = FTP_CHECK_LANG;
    currentLangFtpcStatus = FTPC_LANG_GET_CFG;
    gFtpcGetLangCfgStatus = ftpcStatus;
    /* Foxconn removed, zacker, 08/20/2009 */
    //StartCmdTime = (unsigned int)sys_uptime();
    latestLangTblVersionInfo_init (&gLangTblVerionInfo);
    memset(current_host,0x00,100); /*clear here*/
    strcpy(product_name,  AMBIT_PRODUCT_NAME); /* Foxconn added by Caelia Su 2011/06/15 */
    
    strToLower(product_name);
    get_country_code();


    /* Foxconn Caelia su added start 2011/06/15 */
    apmib_get(MIB_FTP_HOST, (void *)host);
    if(!strcmp(host, ""))
        apmib_getDef(MIB_FTP_HOST, (void *)host);
    apmib_get(MIB_FTP_USER_NAME, (void *)userName);
    if(!strcmp(userName, ""))
        apmib_getDef(MIB_FTP_USER_NAME, (void *)userName);
    apmib_get(MIB_FTP_PASSWORD, (void *)password);
    if(!strcmp(password, ""))
        apmib_getDef(MIB_FTP_PASSWORD, (void *)password);
    /* Foxconn Caelia Su added end 2011/06/15 */

    sprintf (command,
         "rm -f %s %s %s;ftpc -u %s -p %s -f %s -s /%s/%s/%s -d %s &",
         FTPC_PID_FILE,
         FTPC_ERROR_CODE_FILE,
         PATHNAME_LANG_CFG,
         userName,
         password,
         PATHNAME_LANG_CFG,
         product_name,
         fw_country_code,
         "fileinfo.txt",
         host);

    system (command);
}

void ftpc_LangSendGetLangTblCmd (LatestLangTblVersionInfo_t *langTblVersionInfo)
{
    char command[C_MAX_VAR_SIZE] = {0};
    char host[100] = "", userName[10] = "", password[20] = "";

    if (!langTblVersionInfo)
        return;

    ftp_process = FTP_CHECK_LANG;
    currentLangFtpcStatus = FTPC_LANG_GET_TBL;
    gFtpcGetLangTblStatus = FTPC_STATUS_LANG_TBL_IN_PROGRESS;
    /* Foxconn Caelia su added start 2011/06/15 */
    apmib_get(MIB_FTP_HOST, (void *)host);
    if(!strcmp(host, ""))
        apmib_getDef(MIB_FTP_HOST, (void *)host);
    apmib_get(MIB_FTP_USER_NAME, (void *)userName);
    if(!strcmp(userName, ""))
        apmib_getDef(MIB_FTP_USER_NAME, (void *)userName);
    apmib_get(MIB_FTP_PASSWORD, (void *)password);
    if(!strcmp(password, ""))
        apmib_getDef(MIB_FTP_PASSWORD, (void *)password);
    /* Foxconn Caelia Su added end 2011/06/15 */
    /*added by dennis start, fxcn, 07/12/2011, using current host when reconnect occurs*/
    if(!strcmp(current_host, "updates2.netgear.com")||!strcmp(current_host, "updates3.netgear.com")){
        strncpy(host,current_host,100); 
    }
    /*added by dennis end, fxcn, 07/12/2011, using current host when reconnect occurs*/
    sprintf (command,
             "rm -f %s %s %s;ftpc -u %s -p %s -f %s -s %s -d %s &",
             FTPC_PID_FILE,
             FTPC_ERROR_CODE_FILE,
             PATHNAME_LANG_TBL,
             userName,
             password,
             PATHNAME_LANG_TBL,
             langTblVersionInfo->filename,
             host);

    system (command);
}

/*added by dennis start,foxconn,07/06/2011*/




int ftpc_LangAbort (void)/* Foxconn modified by Max Ding, 05/11/2010 */
{
    FILE *pid_fp = NULL;
    char buf[C_MAX_VAR_SIZE] = {0};
    char command[C_MAX_VAR_SIZE] = {0};

    /* Remove all temp files */
    sprintf(command, "rm -f %s %s", PATHNAME_LANG_CFG, PATHNAME_LANG_TBL);
    system(command);

    currentLangFtpcStatus = FTPC_LANG_GET_NONE;/* Foxconn moved by Max Ding, 11/04/2008 */
    
    if (!(pid_fp = fopen (FTPC_PID_FILE, "r")))
    {
        printf ("ftpc.pid: no files!\n");
        return 0;
    }
    if (!fgets (buf, C_MAX_VAR_SIZE, pid_fp))
    {
        printf ("ftpc.pid:fgets() error!!\n");
    }
    if (pid_fp)
    {
        fclose (pid_fp);
        pid_fp = NULL;
    }
    
    if (strlen(buf))
    {
        sprintf (command, "kill -9 %s;rm -f %s %s", buf,
                    FTPC_PID_FILE, FTPC_ERROR_CODE_FILE);
        system (command);
    }

    return OK;
}
/*added by dennis start,foxconn,07/06/2011*/
