#ifndef LANG_H
#define LANG_H

#define MAX_LANG_TBL_LANG_TAG_LEN                   32
#define MAX_LANG_TBL_FILENAME_LEN                   256
#define MAX_LANG_TBL_VER_STR_LEN                    32
#define MAX_LANG_TBL_MD5_STR_LEN                    64
#define MAX_LANG_TBL_SIZE_STR_LEN                   32
#define MAX_REGION_STR_LEN                          32
#define MAX_MD5_LEN                                 16

#define GUI_FOUND 1
#define GUI_NOT_FOUND 2

#define LANG_CHECK_ACTION_NONE      0
#define LANG_CHECK_ACTION_UPDATE    1
#define LANG_CHECK_ACTION_CHANGE    2
#define LANG_CHECK_ACTION_GUI       3

#define PATHNAME_LANG_CFG           "/tmp/lang_cfg"
#define PATHNAME_LANG_TBL           "/tmp/lang_tbl"
/* Foxconn Perry modified start, 2011/02/22, for bzip2 compression */
#define PATHNAME_LANG_TBL_ZIP       "/tmp/lang_tbl.bz2"
/* Foxconn Perry modified end, 2011/02/22, for bzip2 compression */

#define FTPC_PID_FILE               "/var/run/ftpc.pid"
#define FTPC_ERROR_CODE_FILE        "/tmp/ftpc.err"
#define FTPC_LANG_GET_NONE          0x33f0
#define FTPC_LANG_GET_CFG           0x33f1
#define FTPC_LANG_GET_TBL           0x33f2

#define LANG_TBL_VER_STR_DIGIT_NUM                  8//water, 07/21/2009
#define LANG_ENGLISH                                "English"

#ifndef BUILTIN_LANGUAGE
#define BUILTIN_LANGUAGE                       "English"
#endif

#ifndef LANG_TBL_MTD_START
#define LANG_TBL_MTD_START                     2
#endif 

#ifndef ST_SUPPORT_NUM
#define ST_SUPPORT_NUM                         6
#endif

// Status: get config file
#define FTPC_STATUS_LANG_CFG_NONE                   0x50
#define FTPC_STATUS_LANG_CFG_IN_PROGRESS            0x51
#define FTPC_STATUS_LANG_CFG_IN_PROGRESS2           0x52
#define FTPC_STATUS_LANG_CFG_IN_PROGRESS3           0x53
#define FTPC_STATUS_LANG_CFG_NO_MEMORY              0x54
#define FTPC_STATUS_LANG_CFG_GET_FAIL               0x55
#define FTPC_STATUS_LANG_CFG_INVALID                0x56
#define FTPC_STATUS_LANG_CFG_OK                     0x57
#define FTPC_STATUS_LANG_CFG_ABORT_BY_USER          0x58
#define FTPC_STATUS_LANG_CFG_CANNOT_CONNECT_SVR     0x59
#define FTPC_STATUS_LANG_CFG_FILE_UNAVAILABLE       0x5b
#define FTPC_STATUS_LANG_CFG_FILE_SIZE_INCORRECT    0x5c
#define FTPC_STATUS_LANG_CFG_FAIL_EXIT              0x5d
#define FTPC_STATUS_LANG_CFG_OTHER                  0x5f

// Status: get image file
#define FTPC_STATUS_LANG_TBL_NONE                   0x60
#define FTPC_STATUS_LANG_TBL_IN_PROGRESS            0x61
#define FTPC_STATUS_LANG_TBL_NO_MEMORY              0x64
#define FTPC_STATUS_LANG_TBL_GET_FAIL               0x65
#define FTPC_STATUS_LANG_TBL_INVALID                0x66
#define FTPC_STATUS_LANG_TBL_OK                     0x67
#define FTPC_STATUS_LANG_TBL_ABORT_BY_USER          0x68
#define FTPC_STATUS_LANG_TBL_CANNOT_CONNECT_SVR     0x69
#define FTPC_STATUS_LANG_TBL_LOGIN_FAIL             0x6a
#define FTPC_STATUS_LANG_TBL_FILE_UNAVAILABLE       0x6b
#define FTPC_STATUS_LANG_TBL_FILE_SIZE_INCORRECT    0x6c
#define FTPC_STATUS_LANG_TBL_FAIL_EXIT              0x6d
#define FTPC_STATUS_LANG_TBL_OTHER                  0x6f

//Status: write image to flash 
#define FTPC_STATUS_WRITE_LANG_TBL_NONE             0x80
#define FTPC_STATUS_WRITE_LANG_TBL_IN_PROGRESS      0x81
#define FTPC_STATUS_WRITE_LANG_TBL_FAIL             0x82
#define FTPC_STATUS_WRITE_LANG_TBL_OK               0x83

// FTP error code
#define FTPC_ERR_NONE                               0xf0
#define FTPC_ERR_DNS_RESOLER_UPDATE                 0xf1
#define FTPC_ERR_DNS_RESOLE_FAIL                    0xf2
#define FTPC_ERR_HOOKUP_FAIL                        0xf3
#define FTPC_ERR_LOGIN_FAIL                         0xf4
#define FTPC_ERR_GET_FILE_FAIL                      0xf5
#define FTPC_ERR_BUFFER_OVERFLOW                    0xf6
#define FTPC_ERR_ABORT_BY_USER                      0xf7
#define FTPC_ERR_READ_TIMEOUT                       0xf8
#define FTPC_ERR_FILE_UNAVAILABLE                   0xf9
#define FTPC_ERR_OTHERS                             0xfa
#define FTPC_ERR_FAIL_EXIT                          0xff

#if (FW_REGION == BRIC_VERSION)
#define PRODUCT_PATH_EXTRA_TAG      "bric"
#else
#define PRODUCT_PATH_EXTRA_TAG      ""
#endif

typedef struct LatestLangTblVersionInfo_s
{
    unsigned char langtag[MAX_LANG_TBL_LANG_TAG_LEN];
    unsigned char filename[MAX_LANG_TBL_FILENAME_LEN];
    unsigned char version[MAX_LANG_TBL_VER_STR_LEN];
    unsigned char md5[MAX_MD5_LEN];
    unsigned long fileSize;
} LatestLangTblVersionInfo_t;

typedef struct
{
    char lang[32];
    char ver[32];
    unsigned long chksum;
    unsigned long size;
}strTbl_t;

void ftpc_LangSendGetLangTblCmd (LatestLangTblVersionInfo_t *langTblVersionInfo);
void ftpc_LangSendGetLangCfgCmd (int serverIndex, int ftpcStatus);

#endif
