/*
 *      File to define f/w version number
 *
 *      Authors: David Hsu	<davidhsu@realtek.com.tw>
 *
 *      $Id: version.c,v 1.23 2009/08/06 01:10:22 davidhsu Exp $
 *
 */
#include <stdlib.h>
#include <stdio.h>
#include <mtd/mtd-user.h>
#include "version.h" /* Foxconn added by Caelia Su 2011/04/20 */
#include "apmib.h"
#include "apform.h"
#include "ambitCfg.h"
#include "lang.h" /* Foxconn Caelia Su added 2011/06/14 */
#include "../md5.h"
 
/* Foxconn added start by Caelia Su 2011/04/20 */
int fw_found = 0;
int img_found = 0;/* Foxconn added by Max Ding, 05/13/2010 */
//int pgBarCount = 0;
extern int pgbarcount;
extern int ftp_process;
int gFtpcGetStrdatStatus, gFtpcGetCfgStatus, gFtpcGetImgStatus = FTPC_STATUS_IMG_NONE, gWriteImg2FlashStatus;;
int  currentFtpcStatus = FTPC_GET_CFG;
static unsigned int gHeaderLen = 0;
int ver_CheckServerID = 1;
int count_get_strdat = 1;/* Foxconn added by Max Ding, 11/27/2008 */
int count_get_image = 1;/* Foxconn added by Max Ding, 11/27/2008 */
int after_firmware_upgrade;
LatestFwVersionInfo_t gFwVersionInfo;
LatestLangTblVersionInfo_t glangTblVerInfo;
LatestLangTblVersionInfo_t langTblVerInfo;

static ImageInfo_s latestImage;
unsigned int mibVer[4] = {0}; /* Foxconn added by Caelia Su 2011/04/19 */
char fileMD5[40];/* Foxconn add, James Zhou, 02/26/2009 @add_check_md5 */

char fw_region_code[6];/* Foxconn added, zacker, 08/02/2007 */
char fw_country_code[6];/* Foxconn added, zacker, 08/09/2007 */
extern char applyLang[16]; /* Foxconn Caelia Su added 2011/06/13 */
char current_host[100];/*added by dennis, fxcn,07/12/2011, record current_ftp_host*/
/* Foxconn added start by Caelia Su 2011/05/16 */
void strToLower(char *str)
{
    int i, len;

    if(str == NULL)
        return;

    len = strlen(str);
    for(i = 0; i < len; i++)
        str[i] = tolower(str[i]);
}
/* Foxconn added end by Caelia Su 2011/05/16 */

/* Foxconn added start by Caelia Su 2011/04/26 */
/* port from system_util.c */
int create_upgrade_file(void)
{
    int fd;
    
    /* Create tmp file */
    if ((fd = open(TMP_UPGRADE_FILE, O_CREAT)) < 0)
    {
        perror("unable to create tmp file");
        return fd;
    }

    close(fd);
    return 0;
}
/* Foxconn added end by Caelia Su 2011/04/26 */

/* Foxconn added start, zacker, 08/09/2007 */
void get_country_code(void)
{
    int fw_region;
    /*apmib_get(MIB_HW_REGION_NUM, (void *)&fw_region);*/
    fw_region = FW_REGION;
    switch(fw_region)
    {
        case WW_REGION:
            /* Foxconn modified start James, 12/11/2009 @for VGUK */
//#if (ISP_VERSION == ISP_VIRGIN)
#if (defined ISP_VERSION) && (ISP_VERSION == ISP_VIRGIN)/*water, 04/13/2010*/
            strcpy(fw_country_code, "vg");
#else
            strcpy(fw_country_code, "ww");
#endif
            /* Foxconn modified end James, 12/11/2009 @for VGUK */
            strcpy(fw_region_code, "");
            break;
        case NA_REGION:
            strcpy(fw_country_code, "us");
            strcpy(fw_region_code, "NA");
            break;
        case JP_REGION:
            strcpy(fw_country_code, "jp");
            strcpy(fw_region_code, "JP");
            break;
        case GR_REGION:
            strcpy(fw_country_code, "de");
            strcpy(fw_region_code, "GR");
            break;
        case PR_REGION:
            strcpy(fw_country_code, "cn");
            strcpy(fw_region_code, "PR");
            break;
        case KO_REGION:
            strcpy(fw_country_code, "kr");
            strcpy(fw_region_code, "KO");
            break;
        case RU_REGION:
            strcpy(fw_country_code, "ru");
            strcpy(fw_region_code, "RU");
            break;
#if (defined ISP_SK)
        case SK_REGION:
            strcpy(fw_country_code, "sk");
            strcpy(fw_region_code, "SK");
            break; 
#endif
        default:
            strcpy(fw_country_code, "ww");
            strcpy(fw_region_code, "");
            fw_region = WW_REGION;
            break;
    }
}
/* Foxconn added end, zacker, 08/09/2007 */

int ftpc_Abort (void)
{
    /* Remove all temp files */
    char command[256];
    sprintf(command, "rm -f %s %s %s", PATHNAME_CFG, PATHNAME_IMAGE, PATHNAME_STRDAT);
    system(command);
    sprintf (command, "rm -f %s; killall -9 ftpc", "/var/run/ftpc.pid");
    system (command);
    currentFtpcStatus = FTPC_GET_NONE;
    return 1;
}

/* Foxconn add start by James, 02/27/2009 */
int ftpc_GetStringDatStatus(void)
{
    return (gFtpcGetStrdatStatus);
}
/* Foxconn add end by James, 02/27/2009 */

static int ftpc_GetError (int errorCode)
{
    int errbase = 0x00, ret;

    if (currentFtpcStatus == FTPC_GET_IMAGE)
        errbase = 0x10;

    switch (errorCode)
    {
    case FTPC_ERR_NONE:
        ret = FTPC_STATUS_CFG_NONE + errbase;
        break;
    case FTPC_ERR_DNS_RESOLER_UPDATE:
    case FTPC_ERR_DNS_RESOLE_FAIL:
    case FTPC_ERR_HOOKUP_FAIL:
        ret = FTPC_STATUS_CFG_CANNOT_CONNECT_SVR + errbase;
        break;
    case FTPC_ERR_GET_FILE_FAIL:
        ret = FTPC_STATUS_CFG_GET_FAIL + errbase;
        break;
    case FTPC_ERR_BUFFER_OVERFLOW:
        ret = FTPC_STATUS_CFG_NO_MEMORY + errbase;
        break;
    case FTPC_ERR_ABORT_BY_USER:
        ret = FTPC_STATUS_CFG_ABORT_BY_USER + errbase;
        break;
    case FTPC_ERR_READ_TIMEOUT:
        ret = FTPC_STATUS_CFG_INVALID + errbase;
        break;

    case FTPC_ERR_LOGIN_FAIL:
        ret = FTPC_STATUS_IMG_LOGIN_FAIL;
        break;
    case FTPC_ERR_FILE_UNAVAILABLE:
        ret = FTPC_STATUS_CFG_FILE_UNAVAILABLE + errbase;
        break;
    case FTPC_ERR_OTHERS:
    default:
        ret = FTPC_STATUS_CFG_OTHER + errbase;
        break;
    }

    return ret;
}

void ftpc_GotFile (void)
{
    FILE *fp = NULL;
    FILE *fp_cfg = NULL;
    int filesize = 0, dataOffset = 0;
    LatestFwVersionInfo_t fwVerInfo;
    char pathname[64];
    int status = -1, errorcode;
    unsigned char dataBuf[SIZE_CFGFILE] = {0};//Foxconn modified, zacker, 08/02/2007
    unsigned char usBuffer[SIZE_CFGFILE] ={0};//Foxconn added, zacker, 08/02/2007
    LatestLangTblVersionInfo_t langTblVerInfo = {"", "", "", "", 0};//james
    unsigned char tableBuf[SIZE_CFGFILE] = {0};/* Foxconn add by James, 02/27/2009 */


#ifdef VER_CHECK_DEBUG
    printf("ftpc_GotFile()\n");
#endif
    /* Foxconn modify start, Max Ding, 11/27/2008 */
    /* foxconn modified start, zacker, 04/21/2010 */
    errorcode = ftpc_ReadErrorCode ();
#ifdef VER_CHECK_DEBUG
    printf("ftpc_GotFile, errorcode:0x%x, currentFtpcStatus: 0x%x\n", errorcode, currentFtpcStatus);
#endif
    memset (pathname, '\0', sizeof (pathname));
    if (currentFtpcStatus == FTPC_GET_CFG)
    {
        strcpy (pathname, PATHNAME_CFG);
    }
    /* Foxconn add start by James, 02/27/2009 */
    else if (currentFtpcStatus == FTPC_GET_STRDAT)
    {
        if((errorcode >= FTPC_ERR_DNS_RESOLER_UPDATE)
           && (errorcode <= FTPC_ERR_OTHERS)
           && count_get_strdat > 2)
        {
            ver_CheckServerID = 1;
            count_get_strdat = 1;
            status = ftpc_GetError (errorcode);
            goto err;
        }
        count_get_strdat++;
        strcpy (pathname, PATHNAME_STRDAT);
    }
    /* Foxconn add end by James, 02/27/2009 */
    else
    {
        if((errorcode >= FTPC_ERR_DNS_RESOLER_UPDATE)
           && (errorcode <= FTPC_ERR_OTHERS)
           && count_get_image > 2)
        {
            ver_CheckServerID = 1;
            count_get_image = 1;
            status = ftpc_GetError (errorcode);
            goto err;
        }
        count_get_image++;
        strcpy (pathname, PATHNAME_IMAGE);
    }
    /* Foxconn modify end, Max Ding, 11/27/2008 */

    if((errorcode >= FTPC_ERR_DNS_RESOLER_UPDATE)
        && (errorcode <= FTPC_ERR_OTHERS))
    {
        /*added by dennis start,fxcn,07/13/2011,when file doesn't exist in updates1,stop retry*/
        if(errorcode == FTPC_ERR_GET_FILE_FAIL){           
           ver_CheckServerID = 1;
           status = ftpc_GetError (errorcode);
           goto err;
        }
        /*added by dennis end,fxcn,07/13/2011,when file doesn't exist in updates1,stop retry*/
        if (ver_CheckServerID < 3)
        {
            ver_CheckServerID ++;
            printf ("ver_CheckServerID:%d,errorcode:0x%x\n", ver_CheckServerID, errorcode);
            
            if(ver_CheckServerID == 2)
            {
                /* Foxconn add start, Max Ding, 05/13/2010 */
                fw_found = 0;
                img_found = 0;
                //pgFwCheckBarCount = 0;
                /* Foxconn add end, Max Ding, 05/13/2010 */
                ftpc_SendGetCfgCmd (2, FTPC_STATUS_CFG_IN_PROGRESS2);
                status = FTPC_STATUS_CFG_IN_PROGRESS2;
            }
            else
            {
                /* Foxconn add start, Max Ding, 05/13/2010 */
                fw_found = 0;
                img_found = 0;
                //pgFwCheckBarCount = 0;
                /* Foxconn add end, Max Ding, 05/13/2010 */
                ftpc_SendGetCfgCmd (3, FTPC_STATUS_CFG_IN_PROGRESS3);
                status = FTPC_STATUS_CFG_IN_PROGRESS3;
            }
        }
        else
        {
            ver_CheckServerID = 1;
            status = ftpc_GetError (errorcode);
        }
        
        goto err;
    }
    else
    {
        ver_CheckServerID = 1;
        status = ftpc_GetError (errorcode);
        /* Foxconn add start, Max Ding, 11/27/2008 */
        if (currentFtpcStatus == FTPC_GET_CFG)
        {
            ;
        }
        else if (currentFtpcStatus == FTPC_GET_STRDAT)
            count_get_strdat = 1;
        else
            count_get_image = 1;
        /* Foxconn add end, Max Ding, 11/27/2008 */
    }

    if ((fp = fopen (pathname, "r")) == NULL)
    {
        printf ("%s: no files!\n", pathname);
        status = ftpc_GetError (FTPC_ERR_GET_FILE_FAIL);
        goto err;
    }
    else
    {
        if (currentFtpcStatus == FTPC_GET_CFG)
        {
            /* Foxconn modified start, zacker, 08/02/2007 ,read unicode text*/
            //if ((filesize = fread (dataBuf, 1, SIZE_CFGFILE, fp)) <= 0)
            if ((filesize = fread (usBuffer, 1, SIZE_CFGFILE, fp)) <= 0)
            {
                printf ("fread() error for get %s!!\n", pathname);
                status = ftpc_GetError (FTPC_ERR_GET_FILE_FAIL);
                goto err;
            }
            filesize = unicode_file_to_ascii_str(dataBuf, SIZE_CFGFILE, usBuffer, (uint)filesize);
            #ifdef VER_CHECK_DEBUG
            printf("%s\n",dataBuf);
            printf("ascii string size = %d\n", filesize);
            #endif
            /* Foxconn modified end, zacker, 08/02/2007 */
            latestFwVersionInfo_Reset2Default (&fwVerInfo);
            fp_cfg = fopen("/tmp/tmpcfg", "w");
            fprintf(fp_cfg, "%s\n", dataBuf);
            fclose(fp_cfg);
            fp_cfg = fopen("/tmp/tmpcfg", "r");


            //fwrite(dataBuf, filesize, 1, fp_cfg);

            if (OK == parseLatestFwVersionInfo (dataBuf, &fwVerInfo, filesize))
            {
                memcpy (&gFwVersionInfo, &fwVerInfo, sizeof (LatestFwVersionInfo_t));
                status = FTPC_STATUS_CFG_OK;
                /*james*/
                //rewind(fp);

                if (OK == parseLatestLangTblVersionInfo(fp_cfg, applyLang, &langTblVerInfo)) 
#if 0
                if (OK == parseLatestLangTblVersionInfo(buf, acosNvramConfig_get("gui_region"),
                                                        &langTblVerInfo))
#endif

                {
                    memcpy (&glangTblVerInfo, &langTblVerInfo, sizeof(LatestLangTblVersionInfo_t));
                }
#ifdef VER_CHECK_DEBUG
                printf("currentFtpcStatus=%X, status=%X\n",currentFtpcStatus,  status);
#endif
            }
            else
                status = FTPC_STATUS_CFG_INVALID;
            fclose(fp_cfg);
            system("rm -f /tmp/tmpcfg");

        }
        /* Foxconn add start by James Zhou, 02/26/2009 */
        else if (currentFtpcStatus == FTPC_GET_STRDAT)
        {
            if ((filesize = fread (tableBuf, 1, SIZE_STRTBL_DAT, fp)) <= 0)
            {
                printf ("fread() error for get %s!!\n", pathname);
                status = ftpc_GetError (FTPC_ERR_GET_FILE_FAIL);
                goto err;
            }
            status = FTPC_STATUS_CFG_OK;
            filesize = unicode_file_to_ascii_str(dataBuf, SIZE_CFGFILE, usBuffer, (uint)filesize);
        }
        /* Foxconn add end by James Zhou, 02/26/2009 */
        else if (currentFtpcStatus == FTPC_GET_IMAGE)
        {
            /* Foxconn modified start, zacker, 08/02/2007 */
            if ((filesize = fread (dataBuf, 1, SIZE_CFGFILE, fp)) <= 0)
            {
                printf ("fread() error for get %s!!\n", pathname);
                status = ftpc_GetError (FTPC_ERR_GET_FILE_FAIL);
                goto err;
            }
            dataOffset = ver_ReadImgInfo (dataBuf);
            if(dataOffset > 0)
            {    
                /* Foxconn modified start Peter Ling 07/13/2006 */
                /* Move file pointer to start of image */
                fseek(fp, dataOffset, SEEK_SET);
                if ((ver_CheckChecksum (fp) == OK))
                /* Foxconn modified end Peter Ling 07/13/2006 */
                {
                    gHeaderLen = dataOffset;
                    status = FTPC_STATUS_IMG_OK;
                }
                else
                {
                    gHeaderLen = 0;
                    status = FTPC_STATUS_IMG_INVALID;
                }
            }
            else
            {
                gHeaderLen = 0;
                status = FTPC_STATUS_IMG_INVALID;
            }
        }
        else
        {
            printf ("Invalid currentFtpcStatus:%d\n", currentFtpcStatus);
        }
    }

err:
    if (fp)
    {
        fclose (fp);
        fp = NULL;
    }
    if (currentFtpcStatus == FTPC_GET_CFG)
        gFtpcGetCfgStatus = status;
    /* Foxconn add start by James, 02/27/2009 */
    else if (currentFtpcStatus == FTPC_GET_STRDAT)
        gFtpcGetStrdatStatus = status;  
    /* Foxconn add start by James, 02/27/2009 */       
    else
        gFtpcGetImgStatus = status;
#ifdef VER_CHECK_DEBUG
    printf("ftpc_GotFile end, status:0x%x, currentFtpcStatus: 0x%x\n", status, currentFtpcStatus);
#endif
    return;
    /* foxconn modified end, zacker, 04/21/2010 */
}

static int ftpc_ReadErrorCode (void)
{
    FILE *ftpcErr_fp;
    char szID[8];
    int err = -1;

    if (ftpcErr_fp = fopen ("/tmp/ftpc.err", "r"), ftpcErr_fp)
    {
        fread (szID, 8, 1, ftpcErr_fp);
        err = atoi (szID);
        fclose (ftpcErr_fp);
    }
    return err;
}

void latestFwVersionInfo_Reset2Default (LatestFwVersionInfo_t *pFwVerInfo)
{
    #ifdef VER_CHECK_DEBUG
    printf("latestFwVersionInfo_Reset2Default()\n");
    #endif
    pFwVerInfo->boardID[0] = '\0';
    pFwVerInfo->filename[0] = '\0';
    pFwVerInfo->host[0] = '\0';
    pFwVerInfo->fileSize = 0;
}

int ftpc_GetImageFileStatus (void)
{
    return (gFtpcGetImgStatus);
}

void ftpc_SendGetImageCmd (LatestFwVersionInfo_t * fwVersionInfo)
{
    char tmp[512];
    char product_name[MAX_PRODUCT_NAME_LEN] = "";//Foxconn added by zacker
    char host[100] = "", userName[10] = "", password[20] = "";

    ftp_process = FTP_CHECK_FW;
    /* Foxconn add start, Max Ding, 05/11/2010 */
    if (currentFtpcStatus == FTPC_GET_IMAGE)
        return;
    /* Foxconn add end, Max Ding, 05/11/2010 */
    currentFtpcStatus = FTPC_GET_IMAGE;

    strcpy(product_name,  AMBIT_PRODUCT_NAME); /* Foxconn added by Caelia Su 2011/05/16 */
    
    /* Foxconn add end by aspen Bai, 03/02/2009 */
    strToLower(product_name);

    /* Foxconn added start by Caelia Su 2011/05/04 */
    apmib_get(MIB_FTP_HOST, (void *)host);
    if(!strcmp(host, ""))
        apmib_getDef(MIB_FTP_HOST, (void *)host);
    apmib_get(MIB_FTP_USER_NAME, (void *)userName);
    if(!strcmp(userName, ""))
        apmib_getDef(MIB_FTP_USER_NAME, (void *)userName);
    apmib_get(MIB_FTP_PASSWORD, (void *)password);
    if(!strcmp(password, ""))
        apmib_getDef(MIB_FTP_PASSWORD, (void *)password);
    /* Foxconn added end by Caelia Su 2011/05/04 */
    /*added by dennis start, fxcn, 07/12/2011, using current host when reconnect occurs*/
    if(!strcmp(current_host, "updates2.netgear.com")||!strcmp(current_host, "updates3.netgear.com")){
        strncpy(host,current_host,100); 
    }
    /*added by dennis end, fxcn, 07/12/2011, using current host when reconnect occurs*/

    get_country_code();

    sprintf (tmp, "rm -f %s;ftpc -u %s -p %s -f %s -s /%s/%s/%s -d %s &",
             PATHNAME_IMAGE,
             userName, 
             password, 
             PATHNAME_IMAGE,
             product_name,
             fw_country_code,
             fwVersionInfo->filename, host); 

    /* Foxconn modified end, zacker, 05/06/2008 */
    #ifdef VER_CHECK_DEBUG
        printf("ftpc_SendGetImageCmd:%s\n",tmp);
    #endif
    system (tmp);
    //gFtpcGetCfgStatus = FTPC_STATUS_IMG_IN_PROGRESS;
    gFtpcGetImgStatus = FTPC_STATUS_IMG_IN_PROGRESS;/* Foxconn modified by Max Ding, 05/11/2010 */
}

/* Foxconn Caelia Su added start 2011/06/20 */
int ftpc_WriteImgToFlash (void)
{
    unsigned int headerOffset = 0, blockOffset = 0;
    unsigned long dataSize = 0;
    unsigned int kernelLen, rootfsLen;
    FILE *img_fp = NULL;
    char *img_buf = NULL;
    /* Foxconn add start by James Zhou, 02/26/2009 @add_check_md5 */
    unsigned long file_size = 0;
    /* MD5_CTX img_md5;*/ /* Foxconn Caelia Su marked, 2011/06/21 */
    MD5_CONTEXT img_md5;  /* Use realtek's md5 */
    unsigned char digest[16];
    unsigned char calc_md5[32];
    int i = 0;
    int ret = 0;
    /* Foxconn add end by James Zhou, 02/26/2009 @add_check_md5 */

#ifdef VER_CHECK_DEBUG
    printf ("ftpc_WriteImgToFlash()\n");
#endif

    gWriteImg2FlashStatus = FTPC_STATUS_WRITE_IMG_IN_PROGRESS;

    /* upgrade kernel image */
    kernelLen = ver_getkernelSize ();

    /* upgrade rootfs image */
    rootfsLen = ver_getrootfsSize ();
    dataSize = ver_getImageSize() + gHeaderLen;
    if ((img_fp = fopen (PATHNAME_IMAGE, "r")) == NULL)
    {
        printf ("%s: no files!\n", PATHNAME_IMAGE);
        goto err;
    }
    /* Foxconn add start by James Zhou, 02/26/2009 @add_check_md5 */
    calculateFileSize(img_fp, &file_size);

    img_buf = malloc(1024);
    if (img_buf == NULL)
    {
        printf("malloc failed!\n");
        fclose(img_fp); /* Foxconn Caelia Su added 2011/06/20 */
        goto err;
    }

    MD5Init(&img_md5);

    while(i <= file_size)
    {
        ret = fread(img_buf, 1, 1024, img_fp);
        MD5Update(&img_md5, (unsigned char *)img_buf, ret);
        memset(img_buf, '\0', 1024);
        i += ret;
        if (ret == 0)
            break;
    }
    fclose(img_fp); /* Foxconn Caelia Su added 2011/06/20 */

    MD5Final(&digest[0], &img_md5); 

    for(i = 0; i <= 15; i++)
    {
        calc_md5[2*i] = digest[i]/16;
        calc_md5[2*i+1] = digest[i]%16;
        if (calc_md5[2*i] >= 10)
            calc_md5[2*i] += 'A' - 10;
        else
            calc_md5[2*i] += '1' -1;

        if (calc_md5[2*i+1] >= 10)
            calc_md5[2*i+1] += 'A' - 10;
        else
            calc_md5[2*i+1] += '1' - 1;
    }
    free(img_buf);

    printf("Result MD5:\n");
    for(i = 0; i <= 31; i++)
        printf("%c ", calc_md5[i]);
    printf("\n");

    for(i =0; i <=31; i++)
    {
        if (fileMD5[i] != calc_md5[i])
        {
            printf("Check MD5 failed!\n");
            goto err;
        }
    }
    /* Foxconn end start by James Zhou, 02/26/2009 @add_check_md5 */

    return OK;

err:
    gWriteImg2FlashStatus = FTPC_STATUS_WRITE_IMG_FAIL;
    return ERROR;

}
/* Foxconn Caelia Su added end 2011/06/20 */

void ftpc_SendGetStrDatCmd(int ftpcStatus)
{
    char tmp[512];
    char product_name[MAX_PRODUCT_NAME_LEN] = "";//Foxconn added by zacker
    char host[100] = "", userName[10] = "", password[20] = "";

    currentFtpcStatus = FTPC_GET_STRDAT;  
    gFtpcGetStrdatStatus = ftpcStatus;  

    strcpy(product_name,  AMBIT_PRODUCT_NAME); /* Foxconn added by Caelia Su 2011/05/16 */    

    /* Foxconn add end by aspen Bai, 03/02/2009 */
    strToLower(product_name);

    /* Foxconn added start by Caelia Su 2011/05/04 */
    apmib_get(MIB_FTP_HOST, (void *)host);
    if(!strcmp(host, ""))
        apmib_getDef(MIB_FTP_HOST, (void *)host);
    apmib_get(MIB_FTP_USER_NAME, (void *)userName);
    if(!strcmp(userName, ""))
        apmib_getDef(MIB_FTP_USER_NAME, (void *)userName);
    apmib_get(MIB_FTP_PASSWORD, (void *)password);
    if(!strcmp(password, ""))
        apmib_getDef(MIB_FTP_PASSWORD, (void *)password);
    /* Foxconn added end by Caelia Su 2011/05/04 */
     /*added by dennis start, fxcn, 07/12/2011, using current host when reconnect occurs*/
    if(!strcmp(current_host, "updates2.netgear.com")||!strcmp(current_host, "updates3.netgear.com")){
        strncpy(host,current_host,100); 
    }
    /*added by dennis end, fxcn, 07/12/2011, using current host when reconnect occurs*/
    get_country_code();

    sprintf (tmp, "rm -f %s;ftpc -u %s -p %s -f %s -s /%s/%s/%s -d %s -c 1 &", 
         PATHNAME_STRDAT,
         userName,
         password,
         PATHNAME_STRDAT, 
         product_name,
         fw_country_code,
         "stringtable.dat",
         host);

    system (tmp);
}

void ftpc_SendGetCfgCmd (int serverIndex, int ftpcStatus)
{
    char tmp[512];
    char product_name[MAX_PRODUCT_NAME_LEN] = "";
    char host[100] = "", userName[10] = "", password[20] = "";
#ifdef VER_CHECK_DEBUG
    printf ("ftpc_SendGetCfgCmd()\n");  
#endif
    ftp_process = FTP_CHECK_FW;
    currentFtpcStatus = FTPC_GET_CFG;
    gFtpcGetCfgStatus = ftpcStatus;
    memset(current_host,0x00,100); /*clear current_host when start*/
    strcpy(product_name,  AMBIT_PRODUCT_NAME); /* Foxconn added by Caelia Su 2011/05/16 */
    
    /* Foxconn add end by aspen Bai, 03/02/2009 */
    strToLower(product_name);

    /* Foxconn added start by Caelia Su 2011/05/04 */
    apmib_get(MIB_FTP_HOST, (void *)host);
    if(!strcmp(host, ""))
        apmib_getDef(MIB_FTP_HOST, (void *)host);
    

    /* Foxconn Caelia Su added start 2011/06/21 */
    if (serverIndex == 2 || serverIndex == 3) /* Connect to FTP server2 or FTP server3 */
        if (strstr(host, "netgear.com")){ /* The current FTP server is Netgear server */
            sprintf(host, "updates%d.netgear.com", serverIndex);
            sprintf(current_host, "updates%d.netgear.com", serverIndex);/*added by dennis*/
        }
    /* Foxconn Caelia Su added end 2011/06/21 */


    apmib_get(MIB_FTP_USER_NAME, (void *)userName);
    if(!strcmp(userName, ""))
        apmib_getDef(MIB_FTP_USER_NAME, (void *)userName);
    apmib_get(MIB_FTP_PASSWORD, (void *)password);
    if(!strcmp(password, ""))
        apmib_getDef(MIB_FTP_PASSWORD, (void *)password);
    /* Foxconn added end by Caelia Su 2011/05/04 */

    get_country_code();

    sprintf (tmp, "rm -f %s;ftpc -u %s -p %s -f %s -s /%s/%s/%s -d %s -c 1 &", 
         PATHNAME_CFG,
         userName,
         password,
         PATHNAME_CFG, 
         product_name,
         fw_country_code,
         "fileinfo.txt",
         host);
    
    system (tmp);
}

int ftpc_GetConfigFileStatus(LatestFwVersionInfo_t *pFwVerInfo, LatestLangTblVersionInfo_t *plangTblVerInfo)
{
    int status;

    latestFwVersionInfo_Reset2Default(pFwVerInfo);
    latestLangTblVersionInfo_init(plangTblVerInfo);

    status = gFtpcGetCfgStatus;
    if(FTPC_STATUS_CFG_OK == gFtpcGetCfgStatus) {
        memcpy(pFwVerInfo, &gFwVersionInfo, sizeof(LatestFwVersionInfo_t));
        memcpy(plangTblVerInfo, &glangTblVerInfo, sizeof(LatestLangTblVersionInfo_t));
    }
    return status;
}

static unsigned long calculate_checksum (int action, char *s, int size)
{
    static unsigned int c0, c1;
    unsigned int checksum, b;
    int i;

    switch (action)
    {
    case 0:
        c0 = c1 = 0;
        break;
    case 1:
        for (i = 0; i < size; i++)
        {
            c0 += s[i] & 0xff;
            c1 += c0;
        }
        break;
    case 2:
        b = (c0 & 65535) + ((c0 >> 16) & 65535);
        c0 = ((b >> 16) + b) & 65535;

        b = (c1 & 65535) + ((c1 >> 16) & 65535);
        c1 = ((b >> 16) + b) & 65535;

        checksum = ((c1 << 16) | c0);

        return checksum;
    }
    return TRUE;
}

static int isBlankLine (char *pStr)
{
    int i;

    if (pStr == NULL)
        return (TRUE);

    for (i = 0; pStr[i] != '\0'; i++)
    {
        if (!isspace (pStr[i]))
            return (FALSE);
    }
    return (TRUE);
}

int isFwLatest (LatestFwVersionInfo_t * fwVersionInfo)
{
    char fwVersion[100];
    int newVersion[4];  /* wklin modified, 10/04/2008, increase array size */
    int currVersion[4]; /* wklin modified, 10/04/2008 increase array size */
    int newSubVersion = -1, currSubVersion = -1;
    int i;
    int ver_ver, digit_num; /* wklin added, 10/04/2008 */
 
    if (ver_GetFwVersion (fwVersionInfo, newFwVersion) != OK)
        return FALSE;
    for (i = 0; i < 4; i++) /* wklin modified, 10/04/2008 */
    {
        newVersion[i] = 0;
        currVersion[i] = 0;
    }

    /* wklin modified start, 10/04/2008 */
    strcpy(fwVersion,AMBIT_SOFTWARE_VERSION);
    ver_ver = sscanf (fwVersion, "V%d.%d.%d.%d", &currVersion[0],
            &currVersion[1], &currVersion[2], &currVersion[3]);  /* Foxconn modified by Caelia Su 2011/04/19 */
    sscanf (newFwVersion, "%d.%d.%d.%d", &newVersion[0], &newVersion[1],
            &newVersion[2],&newVersion[3]);   /* Foxconn modified by Caelia Su 2011/04/19 */
    memset(newFwVersion, 0x00, sizeof(newFwVersion));
    sprintf(newFwVersion, "%d.%d.%d.%d", newVersion[0], newVersion[1], newVersion[2], newVersion[3]);
#ifdef VER_CHECK_DEBUG
    printf ("product name   = %s\n", fwVersionInfo->boardID);
    printf ("FW version = V%s\n", newFwVersion);

    printf ("curr product name = %s\n", AMBIT_PRODUCT_NAME); /* Foxconn modified by Caelia Su 2011/04/19 */
    printf ("curr version = %s\n", fwVersion); /* Foxconn modified by Caelia Su 2011/04/19 */
#endif

    /* Ambit added start Peter Ling 07/29/2003 */
    digit_num = (ver_ver==4)?4:3;
    if (newVersion[digit_num-1] >= 1000)
    {
        newSubVersion = newVersion[digit_num-1] % 1000;
        newVersion[digit_num-1] /= 1000;
    }
    if (currVersion[digit_num-1] >= 1000)
    {
        currSubVersion = currVersion[digit_num-1] % 1000;
        currVersion[digit_num-1] /= 1000;
    }
    /* Ambit added end Peter Ling 07/29/2003 */

#ifdef VER_CHECK_DEBUG
    for (i = 0; i < digit_num; i++)
        printf ("%d ", newVersion[i]);
    if (newSubVersion != 0)
        printf ("%d", newSubVersion);
    printf ("\n");
    for (i = 0; i < digit_num; i++)
        printf ("%d ", currVersion[i]);
    if (currSubVersion != 0)
        printf ("%d", currSubVersion);
    printf ("\n");
#endif

    for (i = 0; i < digit_num; i++)
    {
        if (newVersion[i] > currVersion[i])
            return TRUE;
        else if (newVersion[i] < currVersion[i])
            return FALSE;
    }

    if (newSubVersion > currSubVersion)
        return TRUE;
    /* wklin modified end, 10/04/2008 */

    return FALSE;
}

static unsigned int ver_getkernelSize (void)
{
    return latestImage.kernelSize;
}

static unsigned int ver_getrootfsSize (void)
{
    return latestImage.rootfsSize;
}

static unsigned int ver_getImageSize (void)
{
    unsigned int imageSize;

    imageSize = ver_getkernelSize () + ver_getrootfsSize ();
    return imageSize;
}

static unsigned int getImageChksum (void)
{
    unsigned int imageChksum = 0;

    imageChksum = latestImage.chksum;
    return imageChksum;
}

static int ver_CheckChecksum (FILE *fp)
{
    unsigned int imageSize = ver_getImageSize ();
    unsigned int imageChksum = getImageChksum ();
    unsigned int calcChksum = 0;
    unsigned char buf[IMAGE_BLOCK_SIZE];
    unsigned int bytes_read, read_size = 0;

#ifdef VER_CHECK_DEBUG
    printf("ver_CheckChecksum(): imageSize=%lu\n", imageSize);
#endif
    
    calculate_checksum (0, NULL, 0);

    /* Foxconn modified start Peter Ling 07/13/2006 */
    /* Loop to accummulate image checksum */
    for (bytes_read=0; bytes_read < imageSize; bytes_read+=read_size)
    {
        if (imageSize - bytes_read >= IMAGE_BLOCK_SIZE)
            read_size = IMAGE_BLOCK_SIZE;
        else
            read_size = imageSize - bytes_read;
        
        fread(buf, 1, read_size, fp);
        calculate_checksum (1, buf, read_size);
    }
    /* Foxconn modified end Peter Ling 07/13/2006 */

    calcChksum = calculate_checksum (2, NULL, 0);

    if (calcChksum == imageChksum)
    {
        #ifdef VER_CHECK_DEBUG
        printf ("\nImage checksum OK (0x%lX)!\n",
                  (unsigned int) imageChksum);
        #endif
        return OK;
    }
    else
    {
        printf ("Checksum error!\n");
        printf ("File checksum = 0x%08X\n", (unsigned int) imageChksum);
        printf ("Calc checksum = 0x%08X\n", (unsigned int) calcChksum);
        return ERROR;
    }

    return OK;
}

static int ver_GetFwVersion (LatestFwVersionInfo_t * fwVersionInfo,
                                  char *version)
{
    if (fwVersionInfo->filename != NULL)
    {        char prefix[256];
        char temp[256];
        //char *fwVersion = NULL;
        char *versionStr = NULL;
        char *dummy = NULL;
        int i;

        sprintf (prefix, "%s-V", AMBIT_PRODUCT_NAME); /* Foxconn modified by Caelia Su 2011/04/19 */
        /* Foxconn mark end by aspen Bai, 11/07/2008 */
        versionStr = stristr (fwVersionInfo->filename, prefix);
        if (versionStr == NULL)
        {
            printf ("[ver_GetFwVersion]%s not found in the file name %s\n",
                 AMBIT_PRODUCT_NAME, fwVersionInfo->filename);
            return ERROR;
        }

        versionStr += strlen (prefix);
        //if (*versionStr == '\0' || strchr (versionStr, '_') == NULL)
        if (*versionStr == '\0')
        {
            printf ("[ver_GetFwVersion]'\\0'and '_' not found in the file name %s\n",
                 fwVersionInfo->filename);
            return ERROR;
        }

        /* Extract version number */
        strcpy (temp, versionStr);
        //fwVersion = strtok_r (temp, "_", &dummy);       // Strip UI version
        dummy = stristr(temp, ".chk");

        if(dummy != NULL)
        {
            for(i = 0; i < strlen(temp); i++)
            {
                if((temp+i) == dummy)
                {
                    temp[i] = '\0';
                    /*foxconn add start, water, 04/30/2009*/
                    /*If the chk name of fileinfo.txt include region code(eg.v1.0.0.1NA),
                      we will show v1.0.0.1NANA.*/
                    if (stristr(temp, "ww") == NULL) /* Foxconn modified by Caelia Su 2011/04/19 */
                    /*foxconn add end, water, 04/30/2009*/
                        strcat(temp, "ww");/* Foxconn modified by Caelia Su 2011/04/19 */
                    strcpy(version, temp);
                    return OK;
                }
            }
        }
        /*
        if (fwVersion != NULL)
        {
            strcpy (version, fwVersion);
            return OK;
        }
        */
        /* Foxconn modified end, zacker, 08/02/2007 */
    }

    return ERROR;
}

int ver_SetImageInfo (ImageInfo_s * imageInfo)
{
#ifdef VER_CHECK_DEBUG
    printf("ver_SetImageInfo()\n");
#endif

    latestImage.chksum = imageInfo->chksum;
    latestImage.kernelSize = imageInfo->kernelSize;
    latestImage.rootfsSize = imageInfo->rootfsSize;
    latestImage.kernelChksum = imageInfo->kernelChksum;
    latestImage.rootfsChksum = imageInfo->rootfsChksum;

#ifdef VER_CHECK_DEBUG
    printf ("image.chksum=%X\n", (unsigned int) latestImage.chksum);
    printf ("image.kernerlSize=%08X\n", (unsigned int) latestImage.kernelSize);
    printf ("image.rootfsSize=%08X\n", (unsigned int) latestImage.rootfsSize);
#endif
    printf ("kernelChksum=0x%lX\n", latestImage.kernelChksum);
    printf ("rootfsChksum=0x%lX\n", latestImage.rootfsChksum);
    return OK;
}

static int ver_ReadImgInfo (char *buf)
{
    char *pData = buf;
    unsigned char headerlen = 0;
    char *imagelenPtr = NULL, *headerPtr = NULL;
    unsigned int kernel_len = 0, rootfs_len = 0, image_chksum = 0;
    ImageInfo_s image;
    unsigned int fileSize;
    unsigned long kernel_chksum, rootfs_chksum;

    #ifdef VER_CHECK_DEBUG
    printf("ver_ReadImgInfo()\n");
    #endif
    
    headerPtr = pData + FIELD_LEN_SIZE;
    headerlen =
        (unsigned int) (headerPtr[3] & 0x000000ff) +
        (unsigned int) ((headerPtr[2] & 0x000000ff) << 8) +
        (unsigned int) ((headerPtr[1] & 0x000000ff) << 16) +
        (unsigned int) ((headerPtr[0] & 0x000000ff) << 24);

    /* check compatible list                   */
    printf ("checking ... ");
    if (abCheckBoardID (pData, 512) != OK)
    {
        printf ("Board ID not matched\n");
        gFtpcGetImgStatus = FTPC_STATUS_IMG_INVALID;
        return ERROR;
    }

    imagelenPtr = pData + 4 * FIELD_CHK_SIZE;
    pData += headerlen;

    /* Foxconn added start Peter Ling 04/06/2006 */
    /* Extract the kernel and rootfs checksums */
    kernel_chksum =
        (unsigned int) (imagelenPtr[3] & 0x000000ff) +
        (unsigned int) ((imagelenPtr[2] & 0x000000ff) << 8) +
        (unsigned int) ((imagelenPtr[1] & 0x000000ff) << 16) +
        (unsigned int) ((imagelenPtr[0] & 0x000000ff) << 24);
    //debugmsg ("kernel_chksum= 0x%X \n", kernel_chksum);
    imagelenPtr += FIELD_LEN_SIZE;
    rootfs_chksum =
        (unsigned int) (imagelenPtr[3] & 0x000000ff) +
        (unsigned int) ((imagelenPtr[2] & 0x000000ff) << 8) +
        (unsigned int) ((imagelenPtr[1] & 0x000000ff) << 16) +
        (unsigned int) ((imagelenPtr[0] & 0x000000ff) << 24);
    //debugmsg ("rootfs_chksum= 0x%X \n", rootfs_chksum);
    imagelenPtr += FIELD_LEN_SIZE;
    /* Foxconn added end Peter Ling 04/06/2006 */
    
    /* Extract the file size of the firmware data */
    /*Extract the kernel size */
    kernel_len =
        (unsigned int) (imagelenPtr[3] & 0x000000ff) +
        (unsigned int) ((imagelenPtr[2] & 0x000000ff) << 8) +
        (unsigned int) ((imagelenPtr[1] & 0x000000ff) << 16) +
        (unsigned int) ((imagelenPtr[0] & 0x000000ff) << 24);
    #ifdef VER_CHECK_DEBUG
    printf ("kernel_len= %X bytes\n", kernel_len);
    #endif
    /* Extract the rootfs size */
    imagelenPtr += FIELD_LEN_SIZE;
    rootfs_len =
        (unsigned int) (imagelenPtr[3] & 0x000000ff) +
        (unsigned int) ((imagelenPtr[2] & 0x000000ff) << 8) +
        (unsigned int) ((imagelenPtr[1] & 0x000000ff) << 16) +
        (unsigned int) ((imagelenPtr[0] & 0x000000ff) << 24);
    #ifdef VER_CHECK_DEBUG
    printf ("rootfs_len= %X bytes\n", rootfs_len);
    #endif
    /* Extract the image checksum value */
    imagelenPtr += FIELD_LEN_SIZE;
    image_chksum =
        (unsigned int) (imagelenPtr[3] & 0x000000ff) +
        (unsigned int) ((imagelenPtr[2] & 0x000000ff) << 8) +
        (unsigned int) ((imagelenPtr[1] & 0x000000ff) << 16) +
        (unsigned int) ((imagelenPtr[0] & 0x000000ff) << 24);
    #ifdef VER_CHECK_DEBUG
    printf ("image_chksum= %X\n", image_chksum);
    #endif
    fileSize = headerlen + kernel_len + rootfs_len;
    image.kernelSize = kernel_len;
    image.rootfsSize = rootfs_len;
    image.chksum = image_chksum;
    /* Foxconn added start Peter Ling 04/06/2006 */
    image.kernelChksum = kernel_chksum;
    image.rootfsChksum = rootfs_chksum;
    /* Foxconn added end Peter Ling 04/06/2006 */
    #ifdef VER_CHECK_DEBUG
    printf ("Downloading firmware - %X bytes\n", fileSize);
    #endif

    if (kernel_len > MAX_SIZE_KERNEL)
    {
        printf ("The kernel image is over %u bytes !!\n", MAX_SIZE_KERNEL);
        gFtpcGetImgStatus = FTPC_STATUS_IMG_INVALID;
        return ERROR;
    }

    if (rootfs_len > MAX_SIZE_ROOTFS)
    {
        printf ("The rootfs image is over %u bytes!!\n", MAX_SIZE_ROOTFS);
        gFtpcGetImgStatus = FTPC_STATUS_IMG_INVALID;
        return ERROR;
    }

    if (fileSize > MAX_SIZE_FILE || fileSize > gFwVersionInfo.fileSize)
    {
        printf("The image is wrong, gFwVerionInfo.fileSize=%d, gotSize=%d!!\n",
             gFwVersionInfo.fileSize, fileSize);
        gFtpcGetImgStatus = FTPC_STATUS_IMG_INVALID;
        return ERROR;
    }
    else
    {
        gFtpcGetImgStatus = FTPC_STATUS_IMG_OK;
        ver_SetImageInfo (&image);
        return headerlen;
    }
}


int stricmp(char *str1, char* str2)
{
    if(!str1 || !str2)
        return 1;

    if(strlen(str1) != strlen(str2))
        return 1;

    for(; *str1; str1++, str2++)
        if(A_TOLOWER(*str1) != A_TOLOWER(*str2))
            return 1;
   
    return 0;
}

/* Case-insensitive strstr */
char *stristr (const char *a, const char *b)
{
    char *c;
    char *d;

    while (*a)
    {
        c = (char *) b;
        d = (char *) a;

        while (*c)
        {
            if (tolower (*c) != tolower (*d))
            {
                break;
            }
            if (!(*d))
            {
                return NULL;    /* a is too short */
            }
            c++;
            d++;
        }

        if (!(*c))
        {
            return (char *) a;
        }
        a++;
    }
    return NULL;
}


int parseLatestFwVersionInfo (char *dataBuf,
                              LatestFwVersionInfo_t * pFwVerInfo,
                              unsigned int dataLen)
{
    char *boardidPtr = NULL;    /* pointer to the board ID string in dataBuf */
    char boardid[MAX_BOARDID_LEN] = {0}; /* Foxconn added, zacker, 08/03/2007 */
    char *filePtr = NULL;       /* pointer to the filename string in dataBuf */
    char *hostPtr = NULL;       /* pointer to the host string in dataBuf */
    char *sizePtr = NULL;       /* pointer to the size string in dataBuf */
    char *dummy, *ptr;
    int endOfFile = FALSE;
    char tmpPtr[100];

    /*char tempptr[MAX_FILENAME_LEN];
    char swuiVer[128];
    char *element = NULL;*/
    
    #ifdef VER_CHECK_DEBUG
    printf("parseLatestFwVersionInfo()\n");
    #endif

    memset(fileMD5, '\0', sizeof(fileMD5));/* Foxconn add by James, 02/26/2009 @add_check_md5 */
    dummy = NULL;
    ptr = strtok_r (dataBuf, "\n", &dummy);

    do
    {
        ptr = strtok_r (NULL, "\n", &dummy);

        if (ptr == NULL)
        {
            printf ("Content of the config file is not valid1.\n");
            return (ERROR);
        }
        
        if(boardidPtr == NULL)
            boardidPtr = parseBoardId (ptr, boardid);
        else
         {
            if (stricmp (boardidPtr, AMBIT_PRODUCT_NAME) != 0)
                break;
         }

        if(filePtr == NULL)
            filePtr = parseFileName(ptr);
        
        if(sizePtr == NULL)
            sizePtr = parseFileSize(ptr);
        
        /* Foxconn add start by James Zhou, 02/26/2009 @add_check_md5 */
        if (strlen(fileMD5) == 0)
            parseFileMD5(ptr, fileMD5, sizeof(fileMD5));
        /* Foxconn add end by James Zhou, 02/26/2009 @add_check_md5 */

        if(!dummy || (dummy == (dataBuf + dataLen)))
        {
            endOfFile = TRUE;
            break;
        }            
        else if (dummy > (dataBuf + dataLen))
        {
            printf ("Content of the config file is not valid10.\n");
            return (ERROR);
        }
    }
    while (((boardidPtr == NULL)||(filePtr == NULL)||(sizePtr == NULL)
                ||(isBlankLine(boardidPtr))||(isBlankLine(filePtr))||(isBlankLine(sizePtr))) 
                && (endOfFile == FALSE));

    apmib_get(MIB_FTP_HOST, (void *)tmpPtr);
    hostPtr = tmpPtr;
    /* Foxconn modified end, zacker, 08/03/2007 */

    /*
       printf("***boardidPtr=%s***\n", boardidPtr);
       printf("***filePtr=%s***\n", filePtr);
       printf("***hostPtr=%s***\n", hostPtr);
       printf("***sizePtr=%s***\n", sizePtr);
     */
    /* ignore additional space */
    #ifdef VER_CHECK_DEBUG
    printf("3. filePtr=%s\n", filePtr);
    #endif      
    while ((filePtr != NULL) && (*filePtr != '\0'))
    {
        if (isspace (*filePtr))
            filePtr++;
        else
            break;
    }
    ptr = filePtr;

    #ifdef VER_CHECK_DEBUG
    printf("4. ptr=%s\n", ptr);
    #endif    
    while ((ptr != NULL) && (*ptr != '\0'))
    {
        if (isspace (*ptr))
        {
            *ptr = '\0';
            break;
        }
        else
            ptr++;
    }
    #ifdef VER_CHECK_DEBUG
    printf("5. hostPtr=%s\n", hostPtr);
    #endif  
    /* ignore additional space */
    while ((hostPtr != NULL) && (*hostPtr != '\0'))
    {
        if (isspace (*hostPtr))
            hostPtr++;
        else
            break;
    }
    ptr = hostPtr;
    #ifdef VER_CHECK_DEBUG
    printf("6. ptr=%s\n", ptr);
    #endif     
    while ((ptr != NULL) && (*ptr != '\0'))
    {
        if (isspace (*ptr))
        {
            *ptr = '\0';
            break;
        }
        else
            ptr++;
    }
    #ifdef VER_CHECK_DEBUG
    printf("7. sizePtr=%s\n", sizePtr);
    #endif       
    /* ignore additional space */
    while ((sizePtr != NULL) && (*sizePtr != '\0'))
    {
        if (isspace (*sizePtr))
            sizePtr++;
        else
            break;
    }
    ptr = sizePtr;
    #ifdef VER_CHECK_DEBUG
    printf("8. ptr=%s\n", ptr);
    #endif     
    while ((ptr != NULL) && (*ptr != '\0'))
    {
        if (isspace (*ptr))
        {
            *ptr = '\0';
            break;
        }
        else
            ptr++;
    }
    #ifdef VER_CHECK_DEBUG
       printf("***filePtr=%s***\n", filePtr);
       printf("***hostPtr=%s***\n", hostPtr);
       printf("***sizePtr=%s***\n", sizePtr);
     #endif
    /* check if any of the above is null */
    /* Foxconn modified, zacker, 08/02/2007, there may be no size section in fileinfo.txt */
     if ((boardidPtr == NULL) || (filePtr == NULL) || (hostPtr == NULL)
        || (boardidPtr[0] == '\0') || (filePtr[0] == '\0') || (hostPtr[0] == '\0'))
    {
        printf ("Content of the LatestVersion file is not valid.\n");
        return (ERROR);
    }

    if (strlen (boardidPtr) > (MAX_BOARDID_LEN - 1))
    {
        printf
            ("Content of the LatestVersion file is not valid.  Size of boardid string too long.\n");
        return (ERROR);
    }

    if (strlen (hostPtr) > (MAX_HOSTNAME_LEN - 1))
    {
        printf
            ("Content of the LatestVersion file is not valid.  Size of Hostname string too long.\n");
        return (ERROR);
    }

    /* check board id, sw version, and hw version */
    if (strlen (filePtr) > (MAX_FILENAME_LEN - 1))
    {
        printf
            ("Content of the LatestVersion file is not valid.  Size of filename string too long.\n");
        return (ERROR);
    }

    #ifdef VER_CHECK_DEBUG
    printf("9. boardidPtr=%s\n", boardidPtr);
    printf("9. filePtr=%s\n", filePtr);
    printf("9. hostPtr=%s\n", hostPtr);
    printf("9. sizePtr=%s\n", sizePtr);
    #endif 
    strcpy (pFwVerInfo->boardID, boardidPtr);
    strcpy (pFwVerInfo->filename, filePtr);
    strcpy (pFwVerInfo->host, hostPtr);
    /* Foxconn modified start, zacker, 08/02/2007 */
    if(sizePtr != NULL)
        pFwVerInfo->fileSize = atoi (sizePtr);      /* convert the size into integer value */
    else
        pFwVerInfo->fileSize = MAX_IMAGE_SIZE;
    /* Foxconn modified end, zacker, 08/02/2007 */

    return (OK);
}

static char *parseBoardId (char *pStr, char *boardID)
{
    /* Foxconn modified start, zacker, 08/02/2007 */
    char *ptr;
    char *ptr_end;

    if (NULL != (ptr = stristr(pStr,"file=")))
    {
        ptr = ptr+strlen("file=");
        if(NULL != (ptr_end = stristr(pStr,"-V"))){
            if(abs(ptr_end-ptr) <= MAX_BOARDID_LEN){
                strncpy(boardID, ptr, abs(ptr_end-ptr));
                return (boardID);
            }
        }

        return NULL;
    }
    else
        return (NULL);
    /* Foxconn modified end, zacker, 08/02/2007 */
}

/* Foxconn added start, zacker, 08/02/2007 */
/* get the image file name from string */
/* Foxconn modified start, james, 01/07/2009 @multi_language */
static char *parseFileName (char *pStr)
{
    char *ptr;
    char *ptr_start;

    if (NULL != (ptr = stristr(pStr,"file=")))
    {
        ptr = ptr+strlen("file=");
        if (NULL != (ptr_start = stristr(ptr, AMBIT_PRODUCT_NAME)))
        {
            return ptr_start;
        }
        return NULL;
        //return (ptr);
    }
    else
        return (NULL);
}
/* get the image file size from string */
static char *parseFileSize(char *pStr)
{
    char *ptr;

    if (NULL != (ptr = stristr(pStr,"size=")))
    {
        ptr = ptr+strlen("size=");
        return (ptr);
    }
    else
        return (NULL);
}
/* Foxconn added end, zacker, 08/02/2007 */

/* Foxconn add start by James Zhou, 02/26/2009 @add_check_md5 */
static int parseFileMD5(char *pStr, char *fileMD5, unsigned long strsize)
{
    char *ptr;

    if (NULL != (ptr = stristr(pStr,"md5=")))
    {
        ptr = ptr+strlen("md5=");
        strncpy(fileMD5, ptr, strsize);
        return OK;
    }
    else
        return ERROR;
}
/* Foxconn add end by James Zhou, 02/26/2009 @add_check_md5 */

/* Foxconn added start, zacker, 08/02/2007 */
/*
 * Convert unicode text file string to ascii text string
 * @param   asciibuf    point to the output converted ascii string
 * @param   asciibufsize   size of input ascii buffer
 * @param   unicodebuf    point to the input little endian unicode text file string
 * @param   unicodebufsize    size of the input little endian unicode text file string
 * @return: the converted characters number
 */
int unicode_file_to_ascii_str(
    unsigned char *asciibuf,
    uint asciibufsize,
    unsigned char *unicodebuf,
    uint unicodebufsize
    )
{
    unsigned char *abuf = asciibuf;
    unsigned char *ubuf = unicodebuf;
    uint asize = asciibufsize;
    uint usize = unicodebufsize;
    uint copycount = 0;
    uint i = 0;

    if ((asize == 0)||(usize < 2)||(abuf == NULL)||(ubuf == NULL))
        return 0;

    if((*ubuf == 0xFF)||(*ubuf == 0xFE)) {
        ubuf = ubuf + 2;
        usize = usize -2;
    } else
        return 0;

    for (i = 0; i < usize-1; ++i) {
        if (--asize == 0)
            break;

        if((*ubuf == '\r')||(*ubuf == '\0')) {
            ubuf++;
        } else {
            *(abuf++) = *(ubuf++);
            copycount++;
        }
    }
    *abuf = '\0';
    copycount++;
    return copycount;
}
/* Foxconn added end, zacker, 08/02/2007 */

/* Foxconn add start by James Zhou, 02/26/2009 @add_check_md5 */
int calculateFileSize(FILE *fd, unsigned long *size)
{
    unsigned long start = 0;
    unsigned long end = 0;

    if (!size)
        return ERROR;
    if (fseek(fd, 0L, SEEK_SET) < 0)
    {
        *size = 0;
        return ERROR;
    }
    if ((start = ftell(fd)) < 0)
    {
        *size = 0;
        return ERROR;
    }
    if (fseek(fd, 0L, SEEK_END) < 0)
    {
        *size = 0;
        return ERROR;
    }
    if ((end = ftell(fd)) < 0)
    {
        *size = 0;
        return ERROR;
    }
    if (fseek(fd, 0L, SEEK_SET) < 0)
    {
        *size = 0;
        return ERROR;
    }
    if ((end - start) < 0)
    {
        *size = 0;
        return ERROR;
    }
    else 
        *size = end - start;

    return OK;
}
/* Foxconn add end by James Zhou, 02/26/2009 @add_check_md5 */
/*modified by dennis*/
/* Foxconn added start by Caelia Su 2011/05/03 */
int verComp(unsigned char *startPtr, unsigned int size)
{
    char tmpVer[50];
    int ver[7];
    int tempLen = 9;
    unsigned char tmpBuf[100];
    unsigned char *buf = startPtr;
    int i = 0;

    memset(tmpBuf, 0x00, sizeof(tmpBuf));
    memcpy(tmpBuf, &buf[0], sizeof(tmpBuf));
    strcpy(tmpVer,AMBIT_SOFTWARE_VERSION);
    buf = strtok(tmpVer, "V._");
    while(buf != NULL){
        ver[i]= atoi(buf);
        buf = strtok(NULL, "V._");
        i++;
    }

    for(i = 0; i < 4; i++)
    {
        printf("tmpBuf[tempLen + i] %d\n",tmpBuf[tempLen + i]);
	printf("ver[i] %d\n",ver[i]);
        if(((int)tmpBuf[tempLen + i]) > ver[i]){
            int region;
            region = FW_REGION;
            if(region == tmpBuf[8])
                return NEWER;
            else{
                if(region == NA_REGION && ((int)tmpBuf[tempLen - 1]) == WW_REGION)
                    return NA2WW;
                else if(region == WW_REGION && ((int)tmpBuf[tempLen - 1]) == NA_REGION)
                    return WW2NA;
                else
                    return UNDEFINED;
            }  
        }else if(((int)tmpBuf[tempLen + i]) < ver[i])
            return OLDER;            
    }
    return SAME;
}
/* Foxconn added end by Caelia Su 2011/05/03 */

int abCheckBoardID (unsigned char *startPtr, unsigned int size)
{
    unsigned long preChecksum = 0, calChecksum = 0;
    unsigned long ComplistLen = 0;
    unsigned char *buf = startPtr;
    int i;
    unsigned char header_buf[80];
    unsigned char boardid[50] = "";

    //unsigned char i;
    unsigned char *idPtr = NULL;
    unsigned char *hdrChkPtr = NULL;
    unsigned char *headerChksum = NULL;
    unsigned long tempLen;
    unsigned char tmpBuf[100];

    memcpy(header_buf, &buf[0], 49);
    header_buf[50] = '\0'; 
    /* search magic number filed, and compare its */
    idPtr = &buf[0];
    if (strcmp (idPtr, FIELD_AMBIT_IDENTIFY) != 0)
    {
        printf ("Not Ambit image ... reject!!!\n");
        return ERROR;
    }

    /* Header checksum */
    idPtr += FIELD_LEN_SIZE;   /*get the header length filed */
    hdrChkPtr = buf + 8 * FIELD_LEN_SIZE + FILES_CHKLEN_SIZE;   /*get the header checksum field */   
    /*header length */
    ComplistLen =
        (unsigned int) (idPtr[3] & 0x000000ff) +
        (unsigned int) ((idPtr[2] & 0x000000ff) << 8) +
        (unsigned int) ((idPtr[1] & 0x000000ff) << 16) +
        (unsigned int) ((idPtr[0] & 0x000000ff) << 24);
    preChecksum =
        (unsigned int) (hdrChkPtr[3] & 0x000000ff) +
        (unsigned int) ((hdrChkPtr[2] & 0x000000ff) << 8) +
        (unsigned int) ((hdrChkPtr[1] & 0x000000ff) << 16) +
        (unsigned int) ((hdrChkPtr[0] & 0x000000ff) << 24);
   
    headerChksum = buf + 8 * FIELD_LEN_SIZE + FILES_CHKLEN_SIZE ;

    for (i = 0; i < FILES_CHKLEN_SIZE; i++)
        *(headerChksum++) = 0x00;       /*set header checksum filed equal "0" */

    memset(tmpBuf, 0x00, sizeof(tmpBuf));
    memcpy(tmpBuf, &buf[0], ComplistLen);
    
    calculate_checksum (0, NULL, 0);
    calculate_checksum (1, (char *) tmpBuf, ComplistLen);
    calChecksum = calculate_checksum (2, NULL, 0);
    tempLen = 8 * FIELD_LEN_SIZE + 2*FILES_CHKLEN_SIZE ;

    if (calChecksum != preChecksum)
    {
        printf ("Header checksum error!!!\n");
        return ERROR;
    }

    /* Foxconn modified start by Caelia Su 2011/04/20 */
   /* apmib_get(MIB_HW_BOARD_ID, (void *)boardid);*/
    sprintf(boardid,"%s_NETGEAR",AMBIT_HARDWARE_VERSION);
    if(!strcmp(boardid, ""))
        strcpy(boardid, "U12H170T00_NETGEAR");
    
    if (strcmp (boardid, (const char *)&tmpBuf[tempLen]) == 0)
       return OK;
   /* Foxconn modified end by Caelia Su 2011/04/20 */

    return ERROR;
}
/* Foxconn added end by Caelia Su 2011/04/20 */

/* Foxconn added start by Caelia Su 2011/05/26 */
/* Porting from verCheckCgi.c */
int verGetNotes(unsigned char *value)
{
    static char tmp[1024] = "";
    static char usbuf[SIZE_CFGFILE] = "";
    static char ascbuf[SIZE_CFGFILE] = "";
    FILE *fp1, *fp2;
    char line[100] = "";
    char line2[1024] = "";
    char htmbuf[1024] = "";
    char *ptr1 = NULL;
    int i = 0;
    unsigned long filesize = 0;
    char *pbuf= NULL;
    char *pstart = NULL;
    char *dummy = NULL;
    char *pline = NULL;
    int  j,k;/*foxconn added, water, 03/16/2009*/
    char version[64] = "";
    int major_pre = 0;
    int major_new = 0;
    int o_pre = 0;
    int o_new = 0;
    int r_pre = 0;
    int r_new = 0;
    int c_pre = 0;
    int c_new = 0;
    int num_new = 0;
    int num_pre = 0;
    char *phead = NULL;
    int nots_ver = 0;
    char *p = NULL;
    int count = 0;

    num_new = sscanf(newFwVersion, "%d.%d.%d.%d", &major_new, &c_new, &r_new, &o_new); /* Foxconn modified by Caelia Su 2011/05/26 */
    num_pre = sscanf(AMBIT_SOFTWARE_VERSION, "V%d.%d.%d.%d", &major_pre, &c_pre, &r_pre, &o_pre);
    if (num_new != 4 || num_pre != 4)
    {
        printf("VerCgi_GetNotes failed, Can't analyse the version!\n");
        return ERROR;
    }

    if ((fp1 = fopen(PATHNAME_CFG, "r")) == NULL)
    {
        sprintf(value,"%s", "");
        return ERROR;
    }

    if ((filesize = fread(usbuf, 1, SIZE_CFGFILE, fp1)) <= 0)
    {
        printf("fread ERROR!\n");
        return ERROR;
    }
    fclose(fp1);
    unicode_file_to_ascii_str(ascbuf, SIZE_CFGFILE, usbuf, (uint)filesize);
    if ((fp1 = fopen(PATHNAME_CFG, "w")) == NULL)
    {
        sprintf(value,"%s", "");
        return ERROR;
    }
    fprintf(fp1, "%s", ascbuf);
    fclose(fp1);
    if ((fp1 = fopen(PATHNAME_CFG, "r")) == NULL)
    {
        sprintf(value,"%s", "");
        return ERROR;
    }

    if ((fp2 = fopen(PATHNAME_STRDAT, "r")) == NULL)
    {
        sprintf(value,"%s", "");
        return ERROR;
    }
    if ((filesize = fread(usbuf, 1, SIZE_STRTBL_DAT, fp2)) <= 0)
    {
        printf("fread ERROR!\n");
        return ERROR;
    }
    fclose(fp2);
    unicode_file_to_ascii_str(ascbuf, SIZE_STRTBL_DAT, usbuf, (uint)filesize);

    while(!feof(fp1))
    {
        memset(line, '\0', 100);
        fgets (line, 100, fp1);
        if (strlen(line) == 0)
            continue;

        if ((ptr1 = strstr(line, "=<MSG")) == NULL)
            continue;

        if ((phead = strchr(line, 'o')) == line)
        {
            nots_ver = atoi(phead + 1);
            if (nots_ver <= o_pre || nots_ver > o_new)
                continue;
        }
        else if ((phead = strchr(line, 'r')) == line)
        {
            nots_ver = atoi(phead + 1);
            if (nots_ver <= r_pre || nots_ver > r_new)
                continue;
        }
        else if ((phead = strchr(line, 'c')) == line)
        {
            nots_ver = atoi(phead + 1);
            if (nots_ver <= c_pre || nots_ver > c_new)
                continue;
        }
        else
            continue;

        ptr1 += 1;
        ptr1 = strtok_r(ptr1, "\n", &dummy);

        pbuf = ascbuf;
        while(NULL != (pline = strtok_r(pbuf , "\n", &dummy)))
        {
            strncpy(line2, pline, 1024);
            if ((pstart = strstr(line2, ptr1)) == NULL)
            {
                pbuf += (strlen(line2)+1);
                continue;
            }
            pstart += (strlen(ptr1)+1);
            strncpy(tmp, pstart, 1024);
            p = tmp;
            for (j=0; j<strlen(p); j++)
            {
                if (p[j] == '\\')
                {
                    if (p[j] == p[j+1])
                    {
                        j ++;
                        continue;
                    }
                    else
                    {
                        p[j] = '\0';
                        i ++;
                        k = 0;
                        memset(htmbuf, '\0', 1024);
                        for(count = 0; count<strlen(p); count++)
                        {
                            if (p[count] == p[count+1] && p[count] == '\\')
                                continue;
                            htmbuf[k++] = p[count];
                        }
                        sprintf(usbuf, HTMLTAG_NOTES, i, htmbuf);
                        strcat(value, usbuf);
                        p = p + j +1;
                        j = 0;
                    }
                }
            }
            i++;
            k = 0;
            memset(htmbuf, '\0', 1024);
            for(count = 0; count<strlen(p); count++)
            {
                if (p[count] == p[count+1] && p[count] == '\\')
                    continue;
                htmbuf[k++] = p[count];
            }
            sprintf(usbuf, HTMLTAG_NOTES, i, htmbuf);
            strcat(value, usbuf);
            break;
        }
    }
    fclose (fp1);
    return OK;
}
